<?php
#=============================================================================================================================
#	File Name		:	AlternateAddressesMaster.php
#=============================================================================================================================
# 

class AlternateAddressesMaster extends CustomClass
{
    public static $Instance;

	public static function obj()
	{
		if(!is_object(self::$Instance))
			self::$Instance = new self();

		return self::$Instance;
	}
    #=========================================================================================================================
	#	Function Name	:   AlternateAddressesMasterData
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
    public function __construct()
    {
		global $config;

		# Initialize all default data

		# Table name
		$this->Data['TableName']			=	$config['Table_Prefix']. 'alternate_address';

		# Module title
		$this->Data['L_Module']				=	'Alternate address Master';

		$this->Data['F_PrimaryKey']			=	'add_id';

		# Intialize parent class
		parent::__construct();
	}
    #=========================================================================================================================
    #	Function Name	:   Insert
    #	Purpose			:	Insert new information
    #	Return			:	Return insert status
    #-------------------------------------------------------------------------------------------------------------------------

	public function InsertAlternateAddresses($Record, $building_id)
    {
		global $asset;
		$borough_code = 0;
		if(isset($Record['county']))
			$borough_code  = $asset['borough_code'][$Record['county']];
		else if(isset($Record['borough']))
			$borough_code  = $Record['borough'];

		$data = $this->getAddressResults($borough_code, $Record['street_number'], $Record['street_name'], $Record['street_suffix']);
		
		if (is_array($data) && isset($data['error'])) {
			echo "<pre>"; print_r($Record['street_number']." ".$Record['street_name']." ". $Record['street_suffix']." : ".$data['error']);
		}

		if (isset($data->display->AddressRangeList) && count($data->display->AddressRangeList)> 0){
			$arrdata = [];
			$arrdata['building_id'] 	= $building_id;
			$arrdata['borough'] 		= $data->display->in_boro;
			$arrdata['block'] 			= $data->display->out_bbl_block;
			$arrdata['lot'] 			= $data->display->out_bbl_lot;
			$arrdata['rpad_bldg_class'] = $data->display->out_rpad_bldg_class;
			$arrdata['latitude'] 		= $data->display->out_lat_property;
			$arrdata['longitude'] 		= $data->display->out_lon_property;
			$arrdata['tax_block'] 		= $data->display->out_bbl_block;
			$arrdata['tax_lot'] 		= $data->display->out_bbl_lot;
			$arrdata['te_is_api'] 		= 'Y';

			foreach ($data->display->AddressRangeList as $address) {
				if(!$this->is_same_address_number($address)){
				
					$arrdata['street_number'] = trim($address->low_address_number);
					$arrdata['street_name'] = trim($address->street_name);
					$arrdata['address'] = trim($address->low_address_number. " " . trim($address->street_name));

					$this->InsertAddress($arrdata);
				}
				$arrdata['street_number'] = trim($address->high_address_number);
				$arrdata['street_name'] = trim($address->street_name);
				$arrdata['address'] = trim($address->high_address_number. " " . trim($address->street_name));

				$this->InsertAddress($arrdata);
			}
		}
		else{

			//echo "<pre>"; print_r($Record['street_number']." ".$Record['street_name']." ". $Record['street_suffix']." : ".print_r($data));

			
			$arrdata = [];
			/*$arrdata['building_id'] 	= $building_id;
			$arrdata['borough'] 		= $borough_code ?? 0;
			$arrdata['block'] 			= $Record['tax_block'];
			$arrdata['lot'] 			= $Record['tax_lot'];
			$arrdata['rpad_bldg_class'] = '';
			$arrdata['latitude'] 		= 0;
			$arrdata['longitude'] 		= 0;
			$arrdata['street_number'] = trim($Record['street_number']);
			$arrdata['street_name'] = trim($Record['street_name']);
			$arrdata['address'] = trim($Record['address2']);
			$arrdata['te_is_api'] 		= 'N';

			$this->InsertAddress($arrdata);*/
		}
        return $arrdata;
    }

	public function InsertAddress($arrdata){
		global $db;

		$sql =	" INSERT INTO ".$this->Data['TableName'].
		" (building_id, street_number, street_name, address, borough, block, lot, rpad_bldg_class, latitude, longitude)".
		" VALUES (
			".$arrdata['building_id'].", 
			'".$arrdata['street_number']."', 
			'".$arrdata['street_name']."', 
			'".$arrdata['address']."', 
			".$arrdata['borough'].", 
			'".$arrdata['block']."', 
			'".$arrdata['lot']."', 
			'".$arrdata['rpad_bldg_class']."',
			".$arrdata['latitude'].", 
			".$arrdata['longitude']."
		)";

		//,'".$arrdata['te_is_api']."'

		$db->query($sql);
		$lastId = $db->Link_ID->insert_id;	
		return $lastId;
	}

	function is_same_address_number($address) {
		$high_address_number = trim($address->high_address_number);
		$low_address_number = trim($address->low_address_number);
	
		if ($high_address_number && $low_address_number) {
			if ($high_address_number == $low_address_number) {
				return true; 
			} else {
				return false; 
			}
		}
		return true; 
	}

	function getAddressResults($borough_code, $street_number, $street_name, $street_suffix){

		$params = array(
			'Borough'       => $borough_code,
			'StreetName'    => rawurlencode($street_number ." ".strtolower($street_name)." ".$street_suffix),
			'Key'			=> 'q4t7wXzBCHFAJkNc',
		);

		$queryString = '';
		foreach ($params as $key => $value) {
			$queryString .= rawurlencode($key) . '=' . $value . '&';
		}
		$queryString = rtrim($queryString, '&');
		$encodedUrl = "https://geoservice.planning.nyc.gov/geoservice/geoservice.svc/Function_1A?" . $queryString;
		
		$result = $this->getResults($encodedUrl); 

		$retry = true;
		/* if(isset($result->display->AddressRangeList) && count($result->display->AddressRangeList)== 0 && $retry && strpos($street_number, '-') === false && strlen($street_number) === 2){
			$streetNumber = $street_number . '-' . $street_number;
			$retry = false;
			return $this->getAddressResults($borough_code, $streetNumber, $street_name, $street_suffix);
		}
		else */ 
		if (isset($result->display->AddressRangeList) && count($result->display->AddressRangeList)== 0 && $retry && strpos($street_number, ' ') !== false){
			$parts = explode(' ', trim($street_number));
			array_pop($parts);
			$streetNumber = implode(' ', $parts);
			$retry = false;
			return $this->getAddressResults($borough_code, $streetNumber, $street_name, $street_suffix);
		}
		else if (isset($result->display->AddressRangeList) && count($result->display->AddressRangeList)== 0 && $retry){
			echo "<pre>"; print_r($encodedUrl);
			$result = $this->getResults($encodedUrl); 
			$retry = false;
		}

		return $result;
	}

	function getResults($encodedUrl){
		$apiResult = Utility::readUrl($encodedUrl);

		if (empty($apiResult) || !isset($apiResult['Result'])) {
			return ['error' => 'API request failed or returned no data'];
		}
		
		return json_decode($apiResult['Result']);
	}

	function verifyAddressExistence($street_number, $street_name, $street_suffix) {
		global $db;
		$buildingId = 0;

		if (!empty($street_number) && strpos($street_number, '-') !== false) {
			$arrStreetNumbers = explode('-', $street_number);
		
			if (count($arrStreetNumbers) === 2 && trim($arrStreetNumbers[0]) === trim($arrStreetNumbers[1])) {
				$streetNumber = trim($arrStreetNumbers[0]);
		
				$fullAddress = trim($streetNumber . ' ' . $street_name . ' ' . $street_suffix);
				$normalized2 = $this->normalizeAddress($fullAddress);
			}
		}

		if (preg_match('/(\d+)(st|nd|rd|th)/i', $street_name, $matches)) {
			$streetName = preg_replace('/(\d+)(st|nd|rd|th)/i', '$1', $street_name);
			$fullAddress = trim($street_number . ' ' . $streetName . ' ' . $street_suffix);
			$normalized3 = $this->normalizeAddress($fullAddress);
			if(isset($streetNumber) && $streetNumber != ''){
				$normalized4 = $this->normalizeAddress(trim($streetNumber . ' ' . $streetName . ' ' . $street_suffix));
			}
		}
		
		$normalized1 = $this->normalizeAddress($street_number." ". $street_name." ".$street_suffix);

		$sql = "SELECT building_id, address FROM " . $this->Data['TableName'];
		$query = $db->query($sql);
		$result = $query->fetch_array();

		foreach ($result as $row) {
			$normalizedDb = $this->normalizeAddress($row['address']);
			if ($normalizedDb === $normalized1 || (isset($normalized2) && $normalizedDb === $normalized2) || (isset($normalized3) && $normalizedDb === $normalized3) || (isset($normalized4) && $normalizedDb === $normalized4)) { 
				$buildingId = $row['building_id'];
				break;
			}
			elseif (preg_match('/(\d+)(st|nd|rd|th)/i', $normalizedDb, $matches) ){
				$normalizedDb2 = preg_replace('/(\d+)(st|nd|rd|th)/i', '$1', $normalizedDb);
				if ($normalizedDb2 === $normalized1 || (isset($normalized2) && $normalizedDb2 === $normalized2) || (isset($normalized3) && $normalizedDb2 === $normalized3) || (isset($normalized4) && $normalizedDb2 === $normalized4)) {
					$buildingId = $row['building_id'];
					break;
				}
			}
		}

		return $buildingId;
	}

	function normalizeAddress($addr) {
		$addr = strtolower(trim($addr));
		$addr = preg_replace('/(\d+)\s*-\s*(\d+)/', '$1$2', $addr);
		$addr = preg_replace('/[^a-z0-9]/', '', $addr);
		return $addr;
	}
	

	function verifyAddressExistenceold($address, $fulladdr){
		global $db;
		$buildingId = 0;
		$address = str_replace([' ', '-'], '%', strtolower(trim($address)));
		$fulladdr = str_replace([' ', '-'], '%', strtolower(trim($fulladdr)));

		$sql =	" Select building_id from ".$this->Data['TableName']. " where (LOWER(address) like '%". $address. "%' or LOWER(address) like '%".$fulladdr."%')";
		$query = $db->query($sql);
        $result = $query->fetch_array();

		if(count($result) > 0){
			$buildingId = $result[0]['building_id'];
		}
		return $buildingId;
	}
}
?>