<?php
#=============================================================================================================================
#	File Name		:	BuildingsMaster.php
#=============================================================================================================================
# 

class BuildingsMaster extends CustomClass
{
    public static $Instance;

	public static function obj()
	{
		if(!is_object(self::$Instance))
			self::$Instance = new self();

		return self::$Instance;
	}
    #=========================================================================================================================
	#	Function Name	:   BuildingMasterData
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
    public function __construct()
    {
		global $config;

		# Initialize all default data

		# Table name
		$this->Data['TableName']			=	$config['Table_Prefix']. 'buildings';

		# Module title
		$this->Data['L_Module']				=	'Buildings Master';

		$this->Data['F_PrimaryKey']			=	'building_id';

		# Intialize parent class
		parent::__construct();
	}
    #=========================================================================================================================
    #	Function Name	:   Insert
    #	Purpose			:	Insert new information
    #	Return			:	Return insert status
    #-------------------------------------------------------------------------------------------------------------------------

public function InsertBuildings($Record, $source)
    {
        global $db, $asset;

		$resultData = [];
		$arrdata = [];
		
		$arrdata['borough_code'] = $asset['borough_code'][$Record['county']];
		$arrdata['building_address'] = $Record['addr'];
		$arrdata['total_units'] = isset($Record['total_units']) ?$Record['total_units']:0;
		$arrdata['garage'] = isset($Record['garage']) ? $Record['garage'] : 0;		
		$arrdata['stories'] = $Record['stories'];
		//$arrdata['rpad_bldg_class'] = $Record['property_type'];
		$arrdata['te_mls_source'] = $source;

		if(isset($Record['building_name']) && !empty($Record['building_name']) && $Record['building_name'] != null && $Record['building_name'] != 'null'){
			$building_name = $this->get_BuildingName_from_variation($Record['building_name']);
		} else
			$building_name = $Record['addr'];

		$arrdata['building_name'] = $this->customUcwords($building_name);

		$sql =	" INSERT INTO ".$this->Data['TableName'].
		" (building_name, building_address, total_units, borough_code, stories, garage, te_mls_source)".
		" VALUES (
			'".$arrdata['building_name']."', 
			'".$arrdata['building_address']."', 
			".$arrdata['total_units'].", 
			".$arrdata['borough_code'].", 
			".$arrdata['stories'].", 
			'".$arrdata['garage']."',
			'".$arrdata['te_mls_source']."'
		)".
		" ON DUPLICATE KEY UPDATE 
			building_name = VALUES(building_name), 
			borough_code = VALUES(borough_code)
		";
		
		$db->query($sql);
		$lastId = $db->Link_ID->insert_id;
		if($lastId == 0){		
			$sql=" SELECT building_id FROM ".$this->Data['TableName']." 
			WHERE building_name='".$arrdata['building_name']."'
			AND borough_code = " . (int)$arrdata['borough_code'] . " LIMIT 1";

            $query = $db->query($sql);
            $result = $query->fetch_array();
            
            if(isset($result[0])){
                $lastId = $result[0]['building_id'];
            }
            else{
                $lastId = 0;
            }
			$resultData['insert'] = false;
		}
		else{
			$resultData['insert'] = true;	
		}
		$resultData['Id'] = $lastId;	
		
        return $resultData;
    }

	function get_BuildingName_from_variation($buildingName ) {
		global $asset;
		$variation = $buildingName;
	
		foreach ($asset['buildingNameVariations'] as $key => $variations) {
			if (in_array($buildingName, $variations)) {
				$variation = $key; 
				break;  
			}
		}
		
		return $variation;
	}

	function customUcwords($input) {
		$words = explode(' ', $input);
		foreach ($words as &$word) {
			if (preg_match('/[a-zA-Z]/', $word)) {
				$word = ucfirst(strtolower($word));  
			}
		}
		return implode(' ', $words);
	}

  	public function InsertAcrisBuildings($Record, $source)
    {
        global $db;
		$arrdata = [];
		$resultData = [];
		
		$arrdata['building_name'] = $this->customUcwords($Record['addr']);
		$arrdata['borough_code'] = $Record['borough'];
		$arrdata['building_address'] = $this->customUcwords($Record['addr']);
		$arrdata['stories'] = $Record['stories'];
		$arrdata['te_mls_source'] = $source;
		$arrdata['te_condo_number'] = $Record['condo_number'];

		$sql =	" INSERT INTO ".$this->Data['TableName'].
		" (building_name, building_address, borough_code, stories, te_mls_source, te_condo_number)".
		" VALUES (
			'".$arrdata['building_name']."', 
			'".$arrdata['building_address']."', 
			'".$arrdata['borough_code']."', 
			".$arrdata['stories'].", 
			'".$arrdata['te_mls_source']."',
			'".$arrdata['condo_number']."'
		)".
		" ON DUPLICATE KEY UPDATE 
			building_name = VALUES(building_name), 
			borough_code = VALUES(borough_code)
		";

		$data = $db->query($sql);
		$lastId = $db->Link_ID->insert_id;
		if($lastId == 0){		
			$sql=" SELECT building_id FROM ".$this->Data['TableName']." 
			WHERE building_name='".$arrdata['building_name']."'
			AND borough_code = " . (int)$arrdata['borough_code'] . " LIMIT 1";

            $query = $db->query($sql);
            $result = $query->fetch_array();
            
            if(isset($result[0])){
                $lastId = $result[0]['building_id'];
            }
            else{
                $lastId = 0;
            }
			$resultData['insert'] = false;
		}
		else{
			$resultData['insert'] = true;
		}
		$resultData['Id'] = $lastId;
        return $resultData;
    }

	function updateBuildingData($buildingId, $arrData, $flag){
		global $db;

		$latitude  = isset($arrData['latitude']) && is_numeric(trim($arrData['latitude'])) ? (float) $arrData['latitude'] : 0;
	    $longitude = isset($arrData['longitude']) && is_numeric(trim($arrData['longitude'])) ? (float) $arrData['longitude'] : 0;

		$sql = "UPDATE " . $this->Data['TableName'] . " SET 
                latitude = " . $latitude . ",
                longitude = " . $longitude . ",
                rpad_bldg_class = '" . $arrData['rpad_bldg_class'] . "',
                borough_code = " . $arrData['borough'] . ",
                is_alt_address = 'Y',
                tax_block = '" . $arrData['tax_block'] . "',
                tax_lot = '" . $arrData['tax_lot'] . "'
                WHERE building_id = " . $buildingId;

		//echo "<pre>2"; print_r($sql);
        $db->query($sql);
		return true;
	}

	function verifyBuildingExistence($street_number, $street_name, $street_suffix, $condo_number="") {
		global $db;
		$buildingId = 0;

		if (!empty($street_number) && strpos($street_number, '-') !== false) {
			$arrStreetNumbers = explode('-', $street_number);
		
			if (count($arrStreetNumbers) === 2 && trim($arrStreetNumbers[0]) === trim($arrStreetNumbers[1])) {
				$streetNumber = trim($arrStreetNumbers[0]);
				$fullAddress = trim($streetNumber . ' ' . $street_name . ' ' . $street_suffix);
				$normalized2 = $this->normalizeBuilding($fullAddress);
			}
		}

		if (preg_match('/\b(\d+)(st|nd|rd|th)\b/i', $street_name, $matches)) {
			$streetName = preg_replace('/\b(\d+)(st|nd|rd|th)\b/i', '$1', $street_name);
			$fullAddress = trim($street_number . ' ' . $streetName . ' ' . $street_suffix);
			$normalized3 = $this->normalizeBuilding($fullAddress);

			if(isset($streetNumber) && $streetNumber != ''){
				$normalized4 = $this->normalizeBuilding(trim($streetNumber . ' ' . $streetName . ' ' . $street_suffix));
			}
		}

		if ( strpos($street_number, ' ') !== false){
			$parts = explode(' ', trim($street_number));
			array_pop($parts);
			$streetNum = implode(' ', $parts);
			$fullAddress = trim($streetNum . ' ' . $street_name . ' ' . $street_suffix);
			$normalized5 = $this->normalizeBuilding($fullAddress);
		}
		
		$normalized1 = $this->normalizeBuilding($street_number." ". $street_name." ".$street_suffix);
		$sql = "SELECT building_id, building_address FROM " . $this->Data['TableName'];
		$query = $db->query($sql);
		$result = $query->fetch_array();

		foreach ($result as $row) {
			$normalizedDb = $this->normalizeBuilding($row['building_address']);
			
			if (!empty($condo_number) && isset($row['condo_number']) && $condo_number == $row['condo_number']) {
				$buildingId = $row['building_id'];
				break;
			}
			elseif ($normalizedDb === $normalized1 || (isset($normalized2) && $normalizedDb === $normalized2) || (isset($normalized3) && $normalizedDb === $normalized3) || (isset($normalized4) && $normalizedDb === $normalized4) || (isset($normalized5) && $normalizedDb === $normalized5)) {
				$buildingId = $row['building_id'];
				break;
			}
			elseif (preg_match('/(\d+)(st|nd|rd|th)/i', $normalizedDb, $matches)) {
				
				$normalizedDb2 = preg_replace('/(\d+)(st|nd|rd|th)/i', '$1', $normalizedDb);

				if ($normalizedDb2 === $normalized1 || (isset($normalized2) && $normalizedDb2 === $normalized2) || (isset($normalized3) && $normalizedDb2 === $normalized3) || (isset($normalized4) && $normalizedDb2 === $normalized4) || (isset($normalized5) && $normalizedDb2 === $normalized5)) {
					$buildingId = $row['building_id'];
					break;
				}
			}
		}

		return $buildingId;
	}

	function normalizeBuilding($building) {
		$building = strtolower(trim($building));
		$building = preg_replace('/(\d+)\s*-\s*(\d+)/', '$1$2', $building);
		$building = preg_replace('/[^a-z0-9]/', '', $building);
		return $building;
	}
}
?>