<?php

use Illuminate\Container\Util;

/**
 * Created by PhpStorm.
 * User: opm1
 * Date: 26/09/19
 * Time: 2:55 PM
 */
class MLS_TRESTLE extends MLSProvider
{
	public $MLSP_ID = 1;
	public $Config = array();
	public $mlsRecord = array();
	public $Data;

	public static $Instance;

	public static function obj($isPopulateSchema=false)
	{
		if(!is_object(self::$Instance) || $isPopulateSchema == true)
			self::$Instance = new self($isPopulateSchema);

		return self::$Instance;
	}
	#=========================================================================================================================
	#	Function Name	:   MLS_TRESTLE
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
	public function __construct($isPopulateSchema=false)
	{
		global $config;

		$this->mlsRecord 					= MLSMaster::obj(true)->getInfoById($this->MLSP_ID);
		# Table Info
		$this->Data['MLS_Listing'] 			= $config['Table_Prefix']. 'te_mls_listing';
		// Temp Tables
		$this->Data['MLS_Listing_ID']		= $config['Table_Prefix']. 'te_mls_listing_id';
		$this->Data['MLS_Tmp_Photo_Data']	= $config['Table_Prefix']. 'mls_photos';
		$this->Data['MLS_Open_House']		= $config['Table_Prefix']. 'mls_open_house';
		$this->Data['MLS_Listing_Sold'] 	= $config['Table_Prefix']. 'mls_listing_sold';
		$this->Data['MLS_Listing_Sold_ID'] 	= $config['Table_Prefix']. 'mls_listing_sold_id';


		$this->Data['MLS_Provider']			= $this->mlsRecord['mls_market_title'] ;
		$this->Config['MLS_Host'] 			= $this->mlsRecord['mls_host'];
		$this->Config['MLS_User'] 			= $this->mlsRecord['mls_user'];
		$this->Config['MLS_Passwd'] 		= $this->mlsRecord['mls_passwd'];
		$this->Config['MLS_User_Agent'] 	= $this->mlsRecord['mls_rets_user_agent'];
		$this->Config['MLS_User_Agent_Passwd'] 	= $this->mlsRecord['mls_rets_user_agent_pwd'];
		$this->Config['MLS_Version'] 		= $this->mlsRecord['mls_rets_version'];
		$this->Config['MLS_Format'] 		= $this->mlsRecord['mls_format'];
		$this->Config['MLS_IS_API'] 		= $this->mlsRecord['mls_is_API'];
		$this->Config['MLS_Client_ID'] 		= $this->mlsRecord['mls_client_id'];
		$this->Config['MLS_Token_URL'] 		= $this->mlsRecord['mls_token_url'];
		$this->Config['MLS_Token_Expire_Time'] = $this->mlsRecord['mls_token_expire_time'];
		$this->Config['MLS_Client_Secret'] 		= $this->mlsRecord['mls_client_secret'];
		$this->Config['MLS_Server_Token'] 		= $this->mlsRecord['mls_server_token'];
		$this->Config['MLS_Browser_Token'] 		= $this->mlsRecord['mls_browser_token'];


		# Make call to parent constructor
		parent::__construct();
	}

	#=========================================================================================================================
	#	Function Name	:   Insert
	#	Purpose			:	Insert new information
	#	Return			:	Return insert status
	#-------------------------------------------------------------------------------------------------------------------------
	public function Insert($mlsp_id, $Resource, $Class, $LookupVal, $LookupField, $Field_Name, $arrData)
	{
		global $db;
		$sql =	" DELETE FROM ". $this->Data['Metadata_Table'] .
			" WHERE MLSP_ID = '".$mlsp_id."' AND Resource = '".$Resource."' AND Lookup_Name = '".$LookupVal."' ";
		$db->query($sql);
		foreach($arrData as $key => $valArr)
		{
			$sql =	" INSERT INTO ". $this->Data['Metadata_Table'] .
				" (MLSP_ID, Resource, Class, Lookup_Name, Lookup_Field, Field_Name, LongValue, ShortValue, IDValue) ".
				" VALUES (".
				" '".$mlsp_id."', ".
				" '".$Resource."', ".
				" '".$Class."', ".
				" '".$LookupVal."', ".
				" '".$LookupField."', ".
				" '".$Field_Name."', ".
				" '".addslashes($valArr['LongValue'])."', ".
				" '".addslashes($valArr['ShortValue'])."', ".
				" '".addslashes($valArr['Value'])."') ".
				" ON DUPLICATE KEY UPDATE ".
				" MLSP_ID = VALUES(MLSP_ID), ".
				" Resource = VALUES(Resource), ".
				" Class = VALUES(Class), ".
				" Lookup_Name = VALUES(Lookup_Name),".
				" Lookup_Field = VALUES(Lookup_Field), ".
				" Field_Name = VALUES(Field_Name), ".
				" IDValue = VALUES(IDValue) ";
			$db->query($sql);
		}
		return true;
	}
	public function doDataTransfer_RETS2Table_API_withoutCustom_property($retsResource, $retsClass, $retsSelect, $FieldList, $TableName, $property_data, $extra_field='', $extra_value='')
	{
		global $db;

		if(count($property_data) > 0)
		{
			$sqlFields = '';
			$rec_no	= 25;
			$cnt	= 0;
			$sql 	= '';

			//$arr_select_query = array_flip(explode(",",$retsSelect));
			$arr_select_query = explode(",",$retsSelect);

			$arr_select_query = array_fill_keys($arr_select_query, '');

			//echo"<pre>";print_r($retsSelect);die;
			foreach($property_data as $key => $data)
			{

				//$arr_select_query = array_flip(explode(",",$retsSelect));

				if(is_array($data) && count($data) > 0)
				{
					if(isset($data['Media']) && is_array($data['Media']))
					{
						$Media = $data['Media'];
					}
					$listing = array_intersect_key($data,$arr_select_query);

					$a_diff = array_diff_key($arr_select_query, $listing);

					if(is_array($a_diff) && count($a_diff) > 0)
					{
						$listing = $listing + $a_diff;
					}
					//Mansi Shah - Sort array as facing data mismatch issue while some colum is missing
					ksort($listing);
				}
				else
				{
					echo "================= ERROR :- Field count mis match ============================ \n";
					//echo"<prE>";print_r($data);
					exit();
				}
				// Create sql field list if not prepared yet
				if($sqlFields == '')
				{
					$temp_1 = explode(",",$retsSelect);
					$temp_2 = explode(",",$FieldList);

					$temp = array_combine($temp_1,$temp_2);

					// FALSE ?
					if($temp === false)
					{
						print("Not able to create sql fields list \n\n");

						return false;
					}

					// Get RETS Fields Name array from listin array, get all keys
					$arrRetsField = array_keys($listing);

					foreach($arrRetsField as $key => $val)
					{
						$sqlFields .= $temp[$val].', ';
					}
					
					// Remove additional comma
					$sqlFields = trim($sqlFields, ', ');

					if(!empty($sqlFields))
					{
						if ($extra_field=='')
							$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
						else
							$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";
					}
					else{
						echo "  ERROR =========== MISSING SQL FIELDS  \n";
						//print_r($property_data);
						exit;
					}
				}
				$arrValues = array_values($listing);
                array_walk($arrValues, function(&$a)
				{
                	if(is_array($a))
					{
						$a = implode(",",$a);
					}
					else
					{
						$a= $a;
					}
				});
                if($extra_field == 'media')
				{
					$extra_value = serialize($Media);
				}

				if($extra_value != '')
				{
					$extra_value = addslashes($extra_value);
				}
			
				$arrValues = array_map( 'addslashes', $arrValues );

				if ($extra_field=='')
					$sql .= "('" . implode("', '", $arrValues) . "'), ";
				else
					$sql .= "('" . implode("', '", $arrValues) . "', '".$extra_value."'), ";


				$cnt++;

				if ($cnt==$rec_no)
				{
					//Insert Data
					$sql = substr($sql,0,strlen($sql)-2);

					# Show debug info
					if(DEBUG)
						$this->__debugMessage($sql);

					$db->db_close();

					$db->reconnect();

					$db->reset_database();

					$db->query($sql);

					$sql = "";
					if ($extra_field=='')
						$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
					else
						$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";

					$cnt = 0;
				}
			}
			if ($extra_field=='')
				$chksql = "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
			else
				$chksql = "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";

			if ($sql!=$chksql)
			{
				//Insert Data
				$sql = substr($sql,0,strlen($sql)-2);

				# Show debug info
				if(DEBUG)
					$this->__debugMessage($sql);

				$db->query($sql);
			}
		}
	}
	public function doDataTransfer_RETS2Table_API($retsResource, $retsClass, $retsSelect, $FieldList, $TableName, $property_data, $extra_field='', $extra_value='', $extra_resource=array())
	{
		global $db;

		if(count($property_data) > 0)
		{
			$sqlFields = '';
			$rec_no	= 25;
			$cnt	= 0;
			$sql 	= '';
			$customProperty = array();
			$extra_field_array = array();

			//$arr_select_query = array_flip(explode(",",$retsSelect));
			$arr_select_query = explode(",",$retsSelect);

			$arr_select_query = array_fill_keys($arr_select_query, '');

			if(is_array($extra_field) && count($extra_field) > 0)
			{
				$extra_field_array = $extra_field;
				$extra_field = implode(", ", $extra_field_array);
			}

			if(in_array('CustomFields', $extra_resource))
			{
				$arr_cus_field = MLSConfig::obj()->arrFieldList['CustomFields'];
				ksort($arr_cus_field);
				$extra_field .= ", ".implode(", ", array_keys($arr_cus_field));
			}
			
			//echo"<pre>";print_r($retsSelect);die;
			foreach($property_data as $key => $data)
			{
				//$arr_select_query = array_flip(explode(",",$retsSelect));

				if(is_array($data) && count($data) > 0)
				{
					if(isset($data['Media']) && is_array($data['Media']))
					{
						$Media = $data['Media'];
					}

					if(isset($data['CustomProperty']) && is_array($data['CustomProperty'])){

						$customProperty = $data['CustomProperty'];
					}
					
					$listing = array_intersect_key($data,$arr_select_query);

					$a_diff = array_diff_key($arr_select_query, $listing);

					if(is_array($a_diff) && count($a_diff) > 0)
					{
						$listing = $listing + $a_diff;
					}
					//Mansi Shah - Sort array as facing data mismatch issue while some colum is missing
					ksort($listing);

					if(in_array('CustomFields', $extra_resource) && isset($customProperty[0]['CustomFields']))
					{
						$cus_f_data = json_decode($customProperty[0]['CustomFields'], true);

						$cus_f_listing = array_intersect_key($cus_f_data, $arr_cus_field);

						$a_cus_f_diff = array_diff_key($arr_cus_field, $cus_f_listing);

						if(is_array($a_cus_f_diff) && count($a_cus_f_diff) > 0)
						{
							$cus_f_listing = array_merge($cus_f_listing, $a_cus_f_diff);
						}
						ksort($cus_f_listing);
					}
				}
				else
				{
					echo "================= ERROR :- Field count mis match ============================ \n";
					//echo"<prE>";print_r($data);
					exit();
				}
				// Create sql field list if not prepared yet
				if($sqlFields == '')
				{
					$temp_1 = explode(",",$retsSelect);
					$temp_2 = explode(",",$FieldList);

					$temp = array_combine($temp_1,$temp_2);

					// FALSE ?
					if($temp === false)
					{
						print("Not able to create sql fields list \n\n");

						return false;
					}

					// Get RETS Fields Name array from listin array, get all keys
					$arrRetsField = array_keys($listing);

					foreach($arrRetsField as $key => $val)
					{
						$sqlFields .= $temp[$val].', ';
					}
					
					// Remove additional comma
					$sqlFields = trim($sqlFields, ', ');

					if(!empty($sqlFields))
					{
						if ($extra_field=='')
							$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
						else
							$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";
					}
					else{
						echo "  ERROR =========== MISSING SQL FIELDS  \n";
						//print_r($property_data);
						exit;
					}
				}
				$arrValues = array_values($listing);
                array_walk($arrValues, function(&$a)
				{
                	if(is_array($a))
					{
						$a = implode(",",$a);
					}
					else
					{
						$a= $a;
					}
				});

				// Mansi Shah : 8 Jan, 2025 - 
                /*if($extra_field == 'media')
				{
					$extra_value = serialize($Media);
				}*/
				//I have commented above media condition and added as below because we need to push media vale in extra_value array and I have taken the reference of it from looptidx.com
				if(in_array("Media", $extra_field_array))
				{
					if(!is_array($extra_value))
					{
						$extra_value = array();
					}
					array_push($extra_value,serialize($Media));
				}
				
				if(in_array('CustomProperty', $extra_resource)){

					if(!is_array($extra_value))
					{
						$extra_value = array();
					}

					$arr_cselect_query = explode(",",$extra_field);

					$arr_cselect_query = array_fill_keys($arr_cselect_query, '');
					
					if(is_array($customProperty) && count($customProperty) > 0){
						$cusListing = array_intersect_key($customProperty[0], $arr_cselect_query);
					}else{
						$cusListing = $arr_cselect_query;
					}
					
					//I have commented below code as we do not need any other fields that are added in extra field and not exist in custom property
					/*$cusa_diff = array_diff_key($arr_cselect_query, $cusListing);

					if(is_array($cusa_diff) && count($cusa_diff) > 0)
					{
						$cusListing = $cusListing + $cusa_diff;
					}*/

					$cus_extra_value = array_values($cusListing);

					if(in_array('CustomFields', $extra_resource) && is_array($cus_f_listing) && count($cus_f_listing) > 0)
					{
						$cus_f_values = array_values($cus_f_listing);
					}
					//Utility::pre($cus_f_values);

					if(is_array($cus_extra_value) && count($cus_extra_value) > 0)
					{
						//$extra_value = $extra_value + $cus_extra_value;
						$extra_value = array_merge($extra_value, $cus_extra_value);

						if(in_array('CustomFields', $extra_resource) &&is_array($cus_f_values) && count($cus_f_values) > 0)
						{
							//$extra_value = $extra_value + $cus_f_values;
							$extra_value = array_merge($extra_value, $cus_f_values);
						}
					}
				}
				if(is_array($extra_field_array) && is_array($extra_value)){
					$extra_value = implode("', '", array_map( 'addslashes', $extra_value));
				}

				// Mansi Shah End - 8 Jan- 2025

				// Hiral - Commented addslashes as it was creating problem with serialise data
				/*if($extra_value != '')
				{
					$extra_value = addslashes($extra_value);
				}*/

				$arrValues = array_map( 'addslashes', $arrValues );

				if ($extra_field=='')
					$sql .= "('" . implode("', '", $arrValues) . "'), ";
				else
					$sql .= "('" . implode("', '", $arrValues) . "', '".$extra_value."'), ";

				$cnt++;

				if ($cnt==$rec_no)
				{
					//Insert Data
					$sql = substr($sql,0,strlen($sql)-2);

					# Show debug info
					if(DEBUG)
						$this->__debugMessage($sql);

					$db->db_close();

					$db->reconnect();

					$db->reset_database();

					$db->query($sql);

					$sql = "";
					if ($extra_field=='')
						$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
					else
						$sql .= "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";

					$cnt = 0;
				}
			}
			if ($extra_field=='')
				$chksql = "REPLACE INTO ".$TableName." (" . $sqlFields . ") VALUES ";
			else
				$chksql = "REPLACE INTO ".$TableName." (" . $sqlFields .", ".$extra_field. ") VALUES ";

			if ($sql!=$chksql)
			{
				//Insert Data
				$sql = substr($sql,0,strlen($sql)-2);

				# Show debug info
				if(DEBUG)
					$this->__debugMessage($sql);
					
				$db->query($sql);
			}
		}
	}
	#=========================================================================================================================
	#	Function Name	:   TransferListingToMst
	#	Purpose			:	data insert from temp table to main table
	#-------------------------------------------------------------------------------------------------------------------------
	function TransferListingToMst()
	{
		global $db;
        // Get total count
		$sql =	" SELECT COUNT(*) AS TotalListing FROM ".$this->Data['MLS_Listing'];
		$rs = $db->query($sql);
		$rs->next_record();
		$TotalListing = $rs->f('TotalListing');

		$page_size = 10000;

		//$page_size = 1000;

		if($TotalListing > 0)
		{
			// Delete invalid data
			$sql =	" DELETE FROM ".$this->Data['MLS_Listing']." WHERE StreetName LIKE '%testing%'";
			$rs = $db->query($sql);

			$sql =	" DELETE FROM ".$this->Data['MLS_Listing']." WHERE State LIKE '%Other%'";
			$rs = $db->query($sql);

			$sql =	" DELETE FROM ".$this->Data['MLS_Listing']." WHERE CityName LIKE '%other%' OR CityName = '' OR CityName IS NULL";
			$rs = $db->query($sql);

			/*$sql =	" DELETE FROM ".$this->Data['MLS_Listing']." WHERE CommonInterest = 'RentalBuilding' ";
			$rs = $db->query($sql);*/
		}

		for($i=0; $i<=$TotalListing; $i=$i+$page_size)
		{
			// Master Data Transfer
			/*$sql =	" INSERT INTO ".$this->Data['TableName'].
				" (MLSP_ID, MLS_NUM, ListingKey, ListingStatus, SubType, BathsFull, BathsHalf, Baths, Beds, ListPrice, OriginalListPrice, 
				SQFT, YearBuilt, Garage, TotalUnits, Tax, TaxBlock, TaxLot, Maintenance, CommonInterest, Commoncharges, Cooling, CrossStreet, 
				CurrentPrice, ExteriorFeatures, HOAFee, NewConstructionYN, OriginatingSystemID, OriginatingSystemKey, Address, Address2, CityName, CityRegion, 
				County, PostalCity, State, UnitNo, StreetName, StreetNumber, StreetSuffix, Subdivision, View, ZipCode, PropertyDesc, ListingDate, LastUpdateDate, Listing_Created_Date, 
				AvailabilityDate, PurchaseContractDate, OnMarketDate, UnderContractDate, is_mark_for_deletion, SoldDate, SoldPrice,
				StreetNumberNumeric, StreetSuffixModifier, StreetDirSuffix, StreetDirPrefix, StreetAdditionalInfo, Agent_Name, BuildingFeatures, BuildingName, BuyerBrokerageCompensation, LaundryFeatures, 
				ListingContractDate, MajorChangeTimestamp, MajorChangeType, OccupantType, Office_Name, OnMarketTimestamp, PatioAndPorchFeatures, PriceChangeTimestamp, PropertyType, Stories, TotalRooms, RentalPrice, ListingType, PreviousListPrice )".
				
				" SELECT ".$this->MLSP_ID.", MLS_NUM, ListingKey, PropertyStatus, SubType, IF(BathsFull  > 0, BathsFull , 0), IF(BathsHalf  > 0, BathsHalf , 0), IF(Baths  > 0, Baths , 0), IF(Beds  > 0, Beds , 0), IF(REPLACE(ListPrice,',','') > 0, REPLACE(ListPrice,',',''), 0), IF(REPLACE(OriginalListPrice,',','') > 0, REPLACE(OriginalListPrice,',',''), 0),
				IF(SQFT > 0, SQFT, 0), YearBuilt, IF(TotalGarage > 0, TotalGarage, 0), IF(TotalUnits > 0, TotalUnits, 0), IF(Tax > 0, Tax, 0), TaxBlock, TaxLot, IF((CommonInterest = 'Condop' OR CommonInterest = 'StockCooperative'), IF(HOAFee > 0, HOAFee, 0), 0), CommonInterest, IF(CommonInterest = 'Condominium', IF(HOAFee > 0, HOAFee, 0), 0), Cooling, CrossStreet,
				IF(REPLACE(CurrentPrice,',','') > 0, REPLACE(CurrentPrice,',',''), 0), ExteriorFeatures, IF(HOAFee > 0, HOAFee, 0), IF(NewConstructionYN = 1, 1, 0), OriginatingSystemID, OriginatingSystemKey, Address, CONCAT_WS(' ', StreetNumber, StreetName, StreetSuffix, StreetDirPrefix, StreetDirSuffix), CityName, CityRegion,
				County, PostalCity, State, UnitNo, StreetName, StreetNumber, StreetSuffix, Subdivision, View, ZipCode, PropertyDesc, ActivationDate, LastUpdateDate, NOW(),
				IF(AvailabilityDate = '', NULL, AvailabilityDate), IF(PurchaseContractDate = '', NULL, PurchaseContractDate), IF(OnMarketDate = '', NULL, OnMarketDate), IF(UnderContractDate = '', NULL, UnderContractDate), 'N',  
				IF(SoldDate = '', NULL, SoldDate), IF(REPLACE(SoldPrice,',','') > 0, REPLACE(SoldPrice,',',''), 0),
				IF(StreetNumberNumeric > 0, StreetNumberNumeric, 0), StreetSuffixModifier, StreetDirSuffix, StreetDirPrefix, StreetAdditionalInfo, Agent_Name, BuildingFeatures, BuildingName, BuyerBrokerageCompensation, LaundryFeatures, 
				ListingContractDate, MajorChangeTimestamp, MajorChangeType, OccupantType, Office_Name, OnMarketTimestamp, PatioAndPorchFeatures, PriceChangeTimestamp, PropertyType, IF(Stories > 0, Stories, 0), IF(TotalRooms > 0, TotalRooms, 0), IF (PropertyStatus = 'Closed', (IF(REPLACE(SoldPrice,',','') > 0, REPLACE(SoldPrice,',',''), 0)), (IF(REPLACE(CurrentPrice,',','') > 0, REPLACE(CurrentPrice,',',''), 0))), IF(PropertyType = 'ResidentialLease', 'Rent', 'Sale' ), IF(REPLACE(PreviousListPrice,',','') > 0, REPLACE(PreviousListPrice,',',''), 0) ".

				" FROM ".$this->Data['MLS_Listing'].
				
				" LIMIT ".$i.", ".$page_size.
				
				" ON DUPLICATE KEY UPDATE 
				ListingKey = VALUES(ListingKey), ListingStatus = VALUES(ListingStatus), SubType = VALUES(SubType), BathsFull = VALUES(BathsFull), 
				BathsHalf = VALUES(BathsHalf), Baths = VALUES(Baths), Beds = VALUES(Beds), ListPrice = VALUES(ListPrice), OriginalListPrice = VALUES(OriginalListPrice), 
				SQFT = VALUES( SQFT), YearBuilt = VALUES(YearBuilt), Garage = VALUES(Garage), TotalUnits = VALUES(TotalUnits), Tax = VALUES(Tax), 
				TaxBlock = VALUES(TaxBlock), TaxLot = VALUES(TaxLot), Maintenance = VALUES(Maintenance), CommonInterest = VALUES(CommonInterest), Cooling = VALUES(Cooling), 
				CrossStreet = VALUES(CrossStreet), CurrentPrice = VALUES( CurrentPrice), ExteriorFeatures = VALUES(ExteriorFeatures), HOAFee = VALUES(HOAFee), 
				NewConstructionYN = VALUES(NewConstructionYN), OriginatingSystemID = VALUES(OriginatingSystemID), OriginatingSystemKey = VALUES(OriginatingSystemKey), 
				Address = VALUES(Address), Address2 = VALUES(Address2), CityName = VALUES(CityName), CityRegion = VALUES(CityRegion), County = VALUES( County), PostalCity = VALUES(PostalCity), 
				State = VALUES(State), UnitNo = VALUES(UnitNo), StreetName = VALUES(StreetName), StreetNumber = VALUES(StreetNumber), StreetSuffix = VALUES(StreetSuffix), 
				Subdivision = VALUES(Subdivision), View = VALUES(View), ZipCode = VALUES(ZipCode), PropertyDesc = VALUES(PropertyDesc), ListingDate = VALUES(ListingDate), 
				LastUpdateDate = VALUES(LastUpdateDate), Listing_Created_Date = VALUES(Listing_Created_Date), AvailabilityDate = VALUES(AvailabilityDate), 
				PurchaseContractDate = VALUES(PurchaseContractDate), OnMarketDate = VALUES(OnMarketDate), UnderContractDate = VALUES(UnderContractDate), 
				is_mark_for_deletion = VALUES(is_mark_for_deletion), SoldDate = VALUES(SoldDate), SoldPrice = VALUES(SoldPrice),
				StreetNumberNumeric = VALUES(StreetNumberNumeric), StreetSuffixModifier = VALUES(StreetSuffixModifier), StreetDirSuffix = VALUES(StreetDirSuffix), StreetDirPrefix = VALUES(StreetDirPrefix), StreetAdditionalInfo = VALUES(StreetAdditionalInfo), 
				Agent_Name = VALUES(Agent_Name), BuildingFeatures = VALUES(BuildingFeatures), BuildingName = VALUES(BuildingName), BuyerBrokerageCompensation = VALUES(BuyerBrokerageCompensation), 
				LaundryFeatures = VALUES(LaundryFeatures), ListingContractDate = VALUES(ListingContractDate), MajorChangeTimestamp = VALUES(MajorChangeTimestamp), MajorChangeType = VALUES(MajorChangeType), OccupantType = VALUES(OccupantType), Office_Name = VALUES(Office_Name), 
				OnMarketTimestamp = VALUES(OnMarketTimestamp), PatioAndPorchFeatures = VALUES(PatioAndPorchFeatures), PriceChangeTimestamp = VALUES(PriceChangeTimestamp), PropertyType = VALUES(PropertyType), Stories = VALUES(Stories), TotalRooms = VALUES(TotalRooms), RentalPrice = VALUES(RentalPrice), ListingType = VALUES(ListingType), PreviousListPrice = VALUES(PreviousListPrice)";
	
			$db->query($sql);*/

			// Sales Data Transfer

			$sql =	" INSERT INTO ".$this->Data['Sales_Table'].
			"(sale_trans_id, price, source, original_entry_timestamp, days_on_market_replication, flip_tax_remarks, tax_monthly_amount, 
			cobroke_agreement, owner_pays_remarks, delivered_vacant_yn, buyer_agent_rls_participant_yn, owner_pays_to_co_broker_yn, 
			compensation_remarks, listing_key, listing_status, subtype, availability_date, purchase_contract_date, listing_date, 
			sold_date, sold_price, agent_name, office_name, on_market_date, under_contract_date, last_update_date, previous_list_price, 
			major_change_timestamp, major_change_type, 
			bathfull, bathhalf, baths, beds, original_list_price, sqft, year_built, garage, total_units, tax, tax_block, tax_lot, 
			maintenance, common_interest, common_charges, cooling, cross_street, current_price, exterior_features, association_fee, 
			newconstruction_yn, originating_system_id, originating_system_key, address, address2, unit_no, street_name, street_number, 
			street_suffix, street_number_numeric, street_suffix_modifier, street_dir_suffix, street_dir_prefix, street_additional_info, 
			city_name, city_region, county, postal_city, state, subdivision, zipcode, view, property_desc, building_features, building_name, 
			buyer_brokerage_compensation, laundry_features, occupant_type, on_market_timestamp, patio_and_porch_features, price_change_timestamp, 
			property_type, stories, total_rooms, 
			exposures, heating, pets_allowed, attic, percent_of_common_elements, elevators_total, kitchen_condition, commercial_units_yn, maximum_financing_remarks, flip_tax_type, 
			tax_abatement_yn, unit_line, bathroom_condition, guarantors_accepted_yn, renting_allowed_yn, flip_tax, closets_total, building_tax_lot, 
			sponsor_unit_yn, certificate_of_occupancy_yn, rental_compensation_type, attendance_type, maximum_financing_percent, owner_pays_plus_concessions_yn, private_outdoor_spacesize,
			building_rules, tax_deduction_amount, tax_deduction_percent, tax_deduction_remarks, garage_yn, 
			te_customfields, te_mlsp_id, te_listing_created_date, te_is_mark_for_deletion )".

			" SELECT MLS_NUM, IF(REPLACE(ListPrice,',','') > 0, REPLACE(ListPrice,',',''), 0), 'Trestle', OriginalEntryTimestamp, IF(DaysOnMarketReplication > 0, DaysOnMarketReplication, 0), FlipTaxRemarks, If(TaxMonthlyAmount > 0, TaxMonthlyAmount, 0), 
			CoBrokeAgreement, OwnerPaysRemarks, IF(DeliveredVacantYN = 1, 1, 0), IF(BuyerAgentRLSParticipantYN = 1, 1, 0), IF(OwnerPaysToCoBrokerYN = 1, 1, 0),
			CompensationRemarks, ListingKey, PropertyStatus, SubType, IF(AvailabilityDate = '', NULL, AvailabilityDate), IF(PurchaseContractDate = '', NULL, PurchaseContractDate), IF(ActivationDate = '', NULL, ActivationDate), 
			IF(SoldDate = '', NULL, SoldDate), IF(REPLACE(SoldPrice,',','') > 0, REPLACE(SoldPrice,',',''), 0), Agent_Name, Office_Name, IF(OnMarketDate = '', NULL, OnMarketDate), IF(UnderContractDate = '', NULL, UnderContractDate), LastUpdateDate, IF(REPLACE(PreviousListPrice,',','') > 0, REPLACE(PreviousListPrice,',',''), 0),
			MajorChangeTimestamp, MajorChangeType, 
			IF(BathsFull  > 0, BathsFull , 0), IF(BathsHalf  > 0, BathsHalf , 0), IF(Baths  > 0, Baths , 0), IF(Beds  > 0, Beds , 0), IF(REPLACE(OriginalListPrice,',','') > 0, REPLACE(OriginalListPrice,',',''), 0), IF(SQFT > 0, SQFT, 0), IF(YearBuilt > 0, YearBuilt, 0), IF(TotalGarage > 0, TotalGarage, 0), IF(TotalUnits > 0, TotalUnits, 0), IF(Tax > 0, Tax, 0), TaxBlock, TaxLot, 
			IF((CommonInterest = 'Condop' OR CommonInterest = 'StockCooperative'), IF(HOAFee > 0, HOAFee, 0), 0), CommonInterest, IF(CommonInterest = 'Condominium', IF(HOAFee > 0, HOAFee, 0), 0), Cooling, CrossStreet, IF(REPLACE(CurrentPrice,',','') > 0, REPLACE(CurrentPrice,',',''), 0), ExteriorFeatures, IF(HOAFee > 0, HOAFee, 0), 
			IF(NewConstructionYN = 1, 1, 0), OriginatingSystemID, OriginatingSystemKey, Address, CONCAT_WS(' ', StreetNumber, StreetName, StreetSuffix, StreetDirPrefix, StreetDirSuffix), UnitNo, StreetName, StreetNumber, 
			StreetSuffix, IF(StreetNumberNumeric > 0, StreetNumberNumeric, 0), StreetSuffixModifier, StreetDirSuffix, StreetDirPrefix, StreetAdditionalInfo, 
			CityName, CityRegion, County, PostalCity, State, Subdivision, ZipCode, View, PropertyDesc, BuildingFeatures, BuildingName, 
			BuyerBrokerageCompensation, LaundryFeatures, OccupantType, OnMarketTimestamp, PatioAndPorchFeatures, PriceChangeTimestamp, 
			PropertyType, IF(Stories > 0, Stories, 0), IF(TotalRooms > 0, TotalRooms, 0),  
			Exposures, Heating, PetsAllowed, Attic, PercentOfCommonElements, ElevatorsTotal, KitchenCondition, IF(CommercialUnitsYN = 1, 1, 0), MaximumFinancingRemarks, FlipTaxType, 
			IF(TaxAbatementYN = 1, 1, 0), UnitLine, BathroomCondition, IF(GuarantorsAcceptedYN = 1, 1, 0), IF(RentingAllowedYN = 1, 1, 0), FlipTax, ClosetsTotal, BuildingTaxLot, 
			IF(SponsorUnitYN = 1, 1, 0), IF(CertificateOfOccupancyYN = 1, 1, 0), RentalCompensationType, AttendanceType, MaximumFinancingPercent, IF(OwnerPaysPlusConcessionsYN = 1, 1, 0), PrivateOutdoorSpaceSize,
			BuildingRules, TaxDeductionAmount, TaxDeductionPercent, TaxDeductionRemarks, IF(GarageYN = 1, 1, 0), 
			CustomFields, ".$this->MLSP_ID.", NOW(), 'N' ".

			" FROM ".$this->Data['MLS_Listing'].
			" WHERE PropertyType = 'Residential' ".		
			" LIMIT ".$i.", ".$page_size.

			" ON DUPLICATE KEY UPDATE ".
			" price = VALUES(price), source = VALUES(source), original_entry_timestamp = VALUES(original_entry_timestamp), days_on_market_replication = VALUES(days_on_market_replication), flip_tax_remarks = VALUES(flip_tax_remarks), tax_monthly_amount = VALUES(tax_monthly_amount), 
			cobroke_agreement = VALUES(cobroke_agreement), owner_pays_remarks = VALUES(owner_pays_remarks), delivered_vacant_yn = VALUES(delivered_vacant_yn), buyer_agent_rls_participant_yn = VALUES(buyer_agent_rls_participant_yn), owner_pays_to_co_broker_yn = VALUES(owner_pays_to_co_broker_yn), 
			compensation_remarks = VALUES(compensation_remarks), listing_key = VALUES(listing_key), listing_status = VALUES(listing_status), subtype = VALUES(subtype), availability_date = VALUES(availability_date), purchase_contract_date = VALUES(purchase_contract_date), listing_date = VALUES(listing_date), 
			sold_date = VALUES(sold_date), sold_price = VALUES(sold_price), agent_name = VALUES(agent_name), office_name = VALUES(office_name), on_market_date = VALUES(on_market_date), under_contract_date = VALUES(under_contract_date), last_update_date = VALUES(last_update_date), previous_list_price = VALUES(previous_list_price), 
			major_change_timestamp = VALUES(major_change_timestamp), major_change_type = VALUES(major_change_type), 
			bathfull = VALUES(bathfull), bathhalf = VALUES(bathhalf), baths = VALUES(baths), beds = VALUES(beds), original_list_price = VALUES(original_list_price), sqft = VALUES(sqft), year_built = VALUES(year_built), garage = VALUES(garage), total_units = VALUES(total_units), tax = VALUES(tax), tax_block = VALUES(tax_block), tax_lot = VALUES(tax_lot), 
			maintenance = VALUES(maintenance), common_interest = VALUES(common_interest), common_charges = VALUES(common_charges), cooling = VALUES(cooling), cross_street = VALUES(cross_street), current_price = VALUES(current_price), exterior_features = VALUES(exterior_features), association_fee = VALUES(association_fee), 
			newconstruction_yn = VALUES(newconstruction_yn), originating_system_id = VALUES(originating_system_id), originating_system_key = VALUES(originating_system_key), address = VALUES(address), address2 = VALUES(address2), unit_no = VALUES(unit_no), street_name = VALUES(street_name), street_number = VALUES(street_number), 
			street_suffix = VALUES(street_suffix), street_number_numeric = VALUES(street_number_numeric), street_suffix_modifier = VALUES(street_suffix_modifier), street_dir_suffix = VALUES(street_dir_suffix), street_dir_prefix = VALUES(street_dir_prefix), street_additional_info = VALUES(street_additional_info), 
			city_name = VALUES(city_name), city_region = VALUES(city_region), county = VALUES(county), postal_city = VALUES(postal_city), state = VALUES(state), subdivision = VALUES(subdivision), zipcode = VALUES(zipcode), view = VALUES(view), property_desc = VALUES(property_desc), building_features = VALUES(building_features), building_name = VALUES(building_name), 
			buyer_brokerage_compensation = VALUES(buyer_brokerage_compensation), laundry_features = VALUES(laundry_features), occupant_type = VALUES(occupant_type), on_market_timestamp = VALUES(on_market_timestamp), patio_and_porch_features = VALUES(patio_and_porch_features), price_change_timestamp = VALUES(price_change_timestamp), 
			property_type = VALUES(property_type), stories = VALUES(stories), total_rooms = VALUES(total_rooms), 
			exposures = VALUES(exposures), heating = VALUES(heating), pets_allowed = VALUES(pets_allowed), attic = VALUES(attic), percent_of_common_elements = VALUES(percent_of_common_elements), elevators_total = VALUES(elevators_total), kitchen_condition = VALUES(kitchen_condition), commercial_units_yn = VALUES(commercial_units_yn), maximum_financing_remarks = VALUES(maximum_financing_remarks), flip_tax_type = VALUES(flip_tax_type), 
			tax_abatement_yn = VALUES(tax_abatement_yn), unit_line = VALUES(unit_line), bathroom_condition = VALUES(bathroom_condition), guarantors_accepted_yn = VALUES(guarantors_accepted_yn), renting_allowed_yn = VALUES(renting_allowed_yn), flip_tax = VALUES(flip_tax), closets_total = VALUES(closets_total), building_tax_lot = VALUES(building_tax_lot), 
			sponsor_unit_yn = VALUES(sponsor_unit_yn), certificate_of_occupancy_yn = VALUES(certificate_of_occupancy_yn), rental_compensation_type = VALUES(rental_compensation_type), attendance_type = VALUES(attendance_type), maximum_financing_percent = VALUES(maximum_financing_percent), owner_pays_plus_concessions_yn = VALUES(owner_pays_plus_concessions_yn), private_outdoor_spacesize = VALUES(private_outdoor_spacesize), 
			building_rules = VALUES(building_rules), tax_deduction_amount = VALUES(tax_deduction_amount), tax_deduction_percent = VALUES(tax_deduction_percent), tax_deduction_remarks = VALUES(tax_deduction_remarks),  garage_yn = VALUES(garage_yn), 
			te_customfields = VALUES(te_customfields), te_is_mark_for_deletion = VALUES(te_is_mark_for_deletion) ";
			
			//echo $sql;die;
			$db->query($sql);
			

			/* ================== Rental Data Transfer ============================ */

			$sql =	" INSERT INTO ".$this->Data['Rentals_Table'].
			"(rental_trans_id, price, source, original_entry_timestamp, days_on_market_replication, flip_tax_remarks, tax_monthly_amount, 
			cobroke_agreement, owner_pays_remarks, delivered_vacant_yn, buyer_agent_rls_participant_yn, owner_pays_to_co_broker_yn, 
			compensation_remarks, listing_key, listing_status, subtype, availability_date, purchase_contract_date, listing_date, 
			sold_date, sold_price, agent_name, office_name, on_market_date, under_contract_date, last_update_date, previous_list_price, 
			major_change_timestamp, major_change_type, 
			bathfull, bathhalf, baths, beds, original_list_price, sqft, year_built, garage, total_units, tax, tax_block, tax_lot, 
			maintenance, common_interest, common_charges, cooling, cross_street, current_price, exterior_features, association_fee, 
			newconstruction_yn, originating_system_id, originating_system_key, address, address2, unit_no, street_name, street_number, 
			street_suffix, street_number_numeric, street_suffix_modifier, street_dir_suffix, street_dir_prefix, street_additional_info, 
			city_name, city_region, county, postal_city, state, subdivision, zipcode, view, property_desc, building_features, building_name, 
			buyer_brokerage_compensation, laundry_features, occupant_type, on_market_timestamp, patio_and_porch_features, price_change_timestamp, 
			property_type, stories, total_rooms, rental_price, 
			exposures, heating, pets_allowed, attic, percent_of_common_elements, elevators_total, kitchen_condition, commercial_units_yn, maximum_financing_remarks, flip_tax_type, 
			tax_abatement_yn, unit_line, bathroom_condition, guarantors_accepted_yn, renting_allowed_yn, flip_tax, closets_total, building_tax_lot, 
			sponsor_unit_yn, certificate_of_occupancy_yn, rental_compensation_type, attendance_type, maximum_financing_percent, owner_pays_plus_concessions_yn, private_outdoor_spacesize, 
			building_rules, tax_deduction_amount, tax_deduction_percent, tax_deduction_remarks, garage_yn, 
			te_customfields, te_mlsp_id, te_listing_created_date, te_is_mark_for_deletion )".

			" SELECT MLS_NUM, IF(REPLACE(ListPrice,',','') > 0, REPLACE(ListPrice,',',''), 0), 'Trestle', OriginalEntryTimestamp, IF(DaysOnMarketReplication > 0, DaysOnMarketReplication, 0), FlipTaxRemarks, If(TaxMonthlyAmount > 0, TaxMonthlyAmount, 0), 
			CoBrokeAgreement, OwnerPaysRemarks, IF(DeliveredVacantYN = 1, 1, 0), IF(BuyerAgentRLSParticipantYN = 1, 1, 0), IF(OwnerPaysToCoBrokerYN = 1, 1, 0),
			CompensationRemarks, ListingKey, PropertyStatus, SubType, IF(AvailabilityDate = '', NULL, AvailabilityDate), IF(PurchaseContractDate = '', NULL, PurchaseContractDate), IF(ActivationDate = '', NULL, ActivationDate), 
			IF(SoldDate = '', NULL, SoldDate), IF(REPLACE(SoldPrice,',','') > 0, REPLACE(SoldPrice,',',''), 0), Agent_Name, Office_Name, IF(OnMarketDate = '', NULL, OnMarketDate), IF(UnderContractDate = '', NULL, UnderContractDate), LastUpdateDate, IF(REPLACE(PreviousListPrice,',','') > 0, REPLACE(PreviousListPrice,',',''), 0),
			MajorChangeTimestamp, MajorChangeType, 
			IF(BathsFull  > 0, BathsFull , 0), IF(BathsHalf  > 0, BathsHalf , 0), IF(Baths  > 0, Baths , 0), IF(Beds  > 0, Beds , 0), IF(REPLACE(OriginalListPrice,',','') > 0, REPLACE(OriginalListPrice,',',''), 0), IF(SQFT > 0, SQFT, 0), IF(YearBuilt > 0, YearBuilt, 0), IF(TotalGarage > 0, TotalGarage, 0), IF(TotalUnits > 0, TotalUnits, 0), IF(Tax > 0, Tax, 0), TaxBlock, TaxLot, 
			IF((CommonInterest = 'Condop' OR CommonInterest = 'StockCooperative'), IF(HOAFee > 0, HOAFee, 0), 0), CommonInterest, IF(CommonInterest = 'Condominium', IF(HOAFee > 0, HOAFee, 0), 0), Cooling, CrossStreet, IF(REPLACE(CurrentPrice,',','') > 0, REPLACE(CurrentPrice,',',''), 0), ExteriorFeatures, IF(HOAFee > 0, HOAFee, 0), 
			IF(NewConstructionYN = 1, 1, 0), OriginatingSystemID, OriginatingSystemKey, Address, CONCAT_WS(' ', StreetNumber, StreetName, StreetSuffix, StreetDirPrefix, StreetDirSuffix), UnitNo, StreetName, StreetNumber, 
			StreetSuffix, IF(StreetNumberNumeric > 0, StreetNumberNumeric, 0), StreetSuffixModifier, StreetDirSuffix, StreetDirPrefix, StreetAdditionalInfo, 
			CityName, CityRegion, County, PostalCity, State, Subdivision, ZipCode, View, PropertyDesc, BuildingFeatures, BuildingName, 
			BuyerBrokerageCompensation, LaundryFeatures, OccupantType, OnMarketTimestamp, PatioAndPorchFeatures, PriceChangeTimestamp, 
			PropertyType, IF(Stories > 0, Stories, 0), IF(TotalRooms > 0, TotalRooms, 0), IF (PropertyStatus = 'Closed', IF(REPLACE(SoldPrice,',','') > 0, REPLACE(SoldPrice,',',''), 0), 0), 
			Exposures, Heating, PetsAllowed, Attic, PercentOfCommonElements, ElevatorsTotal, KitchenCondition, IF(CommercialUnitsYN = 1, 1, 0), MaximumFinancingRemarks, FlipTaxType, 
			IF(TaxAbatementYN = 1, 1, 0), UnitLine, BathroomCondition, IF(GuarantorsAcceptedYN = 1, 1, 0), IF(RentingAllowedYN = 1, 1, 0), FlipTax, ClosetsTotal, BuildingTaxLot, 
			IF(SponsorUnitYN = 1, 1, 0), IF(CertificateOfOccupancyYN = 1, 1, 0), RentalCompensationType, AttendanceType, MaximumFinancingPercent, IF(OwnerPaysPlusConcessionsYN = 1, 1, 0), PrivateOutdoorSpaceSize,
			BuildingRules, TaxDeductionAmount, TaxDeductionPercent, TaxDeductionRemarks, IF(GarageYN = 1, 1, 0), 
			CustomFields, ".$this->MLSP_ID.", NOW(), 'N' ".

			" FROM ".$this->Data['MLS_Listing'].
			" WHERE PropertyType = 'ResidentialLease' ".		
			" LIMIT ".$i.", ".$page_size.

			" ON DUPLICATE KEY UPDATE ".
			" price = VALUES(price), source = VALUES(source), original_entry_timestamp = VALUES(original_entry_timestamp), days_on_market_replication = VALUES(days_on_market_replication), flip_tax_remarks = VALUES(flip_tax_remarks), tax_monthly_amount = VALUES(tax_monthly_amount), 
			cobroke_agreement = VALUES(cobroke_agreement), owner_pays_remarks = VALUES(owner_pays_remarks), delivered_vacant_yn = VALUES(delivered_vacant_yn), buyer_agent_rls_participant_yn = VALUES(buyer_agent_rls_participant_yn), owner_pays_to_co_broker_yn = VALUES(owner_pays_to_co_broker_yn), 
			compensation_remarks = VALUES(compensation_remarks), listing_key = VALUES(listing_key), listing_status = VALUES(listing_status), subtype = VALUES(subtype), availability_date = VALUES(availability_date), purchase_contract_date = VALUES(purchase_contract_date), listing_date = VALUES(listing_date), 
			sold_date = VALUES(sold_date), sold_price = VALUES(sold_price), agent_name = VALUES(agent_name), office_name = VALUES(office_name), on_market_date = VALUES(on_market_date), under_contract_date = VALUES(under_contract_date), last_update_date = VALUES(last_update_date), previous_list_price = VALUES(previous_list_price), 
			major_change_timestamp = VALUES(major_change_timestamp), major_change_type = VALUES(major_change_type), 
			bathfull = VALUES(bathfull), bathhalf = VALUES(bathhalf), baths = VALUES(baths), beds = VALUES(beds), original_list_price = VALUES(original_list_price), sqft = VALUES(sqft), year_built = VALUES(year_built), garage = VALUES(garage), total_units = VALUES(total_units), tax = VALUES(tax), tax_block = VALUES(tax_block), tax_lot = VALUES(tax_lot), 
			maintenance = VALUES(maintenance), common_interest = VALUES(common_interest), common_charges = VALUES(common_charges), cooling = VALUES(cooling), cross_street = VALUES(cross_street), current_price = VALUES(current_price), exterior_features = VALUES(exterior_features), association_fee = VALUES(association_fee), 
			newconstruction_yn = VALUES(newconstruction_yn), originating_system_id = VALUES(originating_system_id), originating_system_key = VALUES(originating_system_key), address = VALUES(address), address2 = VALUES(address2), unit_no = VALUES(unit_no), street_name = VALUES(street_name), street_number = VALUES(street_number), 
			street_suffix = VALUES(street_suffix), street_number_numeric = VALUES(street_number_numeric), street_suffix_modifier = VALUES(street_suffix_modifier), street_dir_suffix = VALUES(street_dir_suffix), street_dir_prefix = VALUES(street_dir_prefix), street_additional_info = VALUES(street_additional_info), 
			city_name = VALUES(city_name), city_region = VALUES(city_region), county = VALUES(county), postal_city = VALUES(postal_city), state = VALUES(state), subdivision = VALUES(subdivision), zipcode = VALUES(zipcode), view = VALUES(view), property_desc = VALUES(property_desc), building_features = VALUES(building_features), building_name = VALUES(building_name), 
			buyer_brokerage_compensation = VALUES(buyer_brokerage_compensation), laundry_features = VALUES(laundry_features), occupant_type = VALUES(occupant_type), on_market_timestamp = VALUES(on_market_timestamp), patio_and_porch_features = VALUES(patio_and_porch_features), price_change_timestamp = VALUES(price_change_timestamp), 
			property_type = VALUES(property_type), stories = VALUES(stories), total_rooms = VALUES(total_rooms), rental_price = VALUES(rental_price), 
			exposures = VALUES(exposures), heating = VALUES(heating), pets_allowed = VALUES(pets_allowed), attic = VALUES(attic), percent_of_common_elements = VALUES(percent_of_common_elements), elevators_total = VALUES(elevators_total), kitchen_condition = VALUES(kitchen_condition), commercial_units_yn = VALUES(commercial_units_yn), maximum_financing_remarks = VALUES(maximum_financing_remarks), flip_tax_type = VALUES(flip_tax_type), 
			tax_abatement_yn = VALUES(tax_abatement_yn), unit_line = VALUES(unit_line), bathroom_condition = VALUES(bathroom_condition), guarantors_accepted_yn = VALUES(guarantors_accepted_yn), renting_allowed_yn = VALUES(renting_allowed_yn), flip_tax = VALUES(flip_tax), closets_total = VALUES(closets_total), building_tax_lot = VALUES(building_tax_lot), 
			sponsor_unit_yn = VALUES(sponsor_unit_yn), certificate_of_occupancy_yn = VALUES(certificate_of_occupancy_yn), rental_compensation_type = VALUES(rental_compensation_type), attendance_type = VALUES(attendance_type), maximum_financing_percent = VALUES(maximum_financing_percent), owner_pays_plus_concessions_yn = VALUES(owner_pays_plus_concessions_yn), private_outdoor_spacesize = VALUES(private_outdoor_spacesize), 
			building_rules = VALUES(building_rules), tax_deduction_amount = VALUES(tax_deduction_amount), tax_deduction_percent = VALUES(tax_deduction_percent), tax_deduction_remarks = VALUES(tax_deduction_remarks),  garage_yn = VALUES(garage_yn), 
			te_customfields = VALUES(te_customfields), te_is_mark_for_deletion = VALUES(te_is_mark_for_deletion) ";
			
			//echo $sql;die;
			$db->query($sql);
		}

		return true;
	}
	#=========================================================================================================================
	#	Function Name	:   UpdateListingLog
	#	Use				:	Maintain listing history like New listing or price updated or deleted listing or status changed
	#-------------------------------------------------------------------------------------------------------------------------
	public function UpdateListingLog($MLSP_ID, $log_last_update_date)
	{
		global $db;

		$sql =	" INSERT INTO ".$this->Data['Listing_Log'].
			" (lslog_mls_num, lslog_mlsp_id, lslog_status, lslog_actual_status, lslog_old_status, lslog_price, lslog_price_per_sqft, lslog_old_price, lslog_price_diff, lslog_source, lslog_ref_date, lslog_date)".

			" SELECT LM.MLS_NUM, LM.MLSP_ID,".
			" CASE WHEN (DATE_FORMAT(Listing_Created_Date, '%Y-%m-%d') = CURDATE()) THEN 'Listed' WHEN (ListingStatus != lslog_actual_status AND LM.is_mark_for_deletion = 'N' ) THEN 'Status Change' WHEN (ListPrice != lslog_price) THEN 'Price Change' WHEN (LM.is_mark_for_deletion = 'Y' AND DATE_FORMAT(LastUpdateDate, '%Y-%m-%d') = CURDATE()) THEN 'Listing Removed' END,".
			" ListingStatus, lslog_actual_status, ListPrice, IF(SQFT > 0, ListPrice/SQFT, 0), lslog_price, IF(lslog_price > 0, (lslog_price-ListPrice)*100*(-1)/lslog_price, 0), Office_Name, ".
			" CASE WHEN (DATE_FORMAT(Listing_Created_Date, '%Y-%m-%d') = CURDATE() AND ListingStatus = 'Active' ) THEN DATE_FORMAT(Listing_Created_Date, '%Y-%m-%d') WHEN (ListingStatus = 'Active with Contract') THEN DATE_FORMAT(LastUpdateDate, '%Y-%m-%d') ELSE CURDATE() END,".
			" CURDATE()".
			" FROM ".$this->Data['TableName']." AS LM".
			" LEFT JOIN ". $this->Data['Office_Table']." AS O ON LM.OfficeID = O.Office_ID AND LM.MLSP_ID = O.Office_MLSP_ID ".
			" LEFT JOIN ".$this->Data['Listing_Log']." AS PL ON PL.lslog_mls_num = LM.MLS_NUM AND PL.lslog_mlsp_id = LM.MLSP_ID".
			" AND lslog_datetime = (SELECT lslog_datetime FROM ".$this->Data['Listing_Log']." WHERE lslog_mls_num = PL.lslog_mls_num AND lslog_mlsp_id = PL.lslog_mlsp_id ORDER BY lslog_datetime DESC LIMIT 1)".

			" WHERE ListingStatus IN ('Active','ActiveUnderContract') AND (Listing_Created_Date >= '$log_last_update_date' OR LastUpdateDate >= '$log_last_update_date') AND (".
			" (DATE_FORMAT(Listing_Created_Date, '%Y-%m-%d') = CURDATE())". 		// New Listing
			" OR (ListPrice != lslog_price)". 					// Price Changed
			" OR (LM.is_mark_for_deletion = 'Y' AND DATE_FORMAT(LastUpdateDate, '%Y-%m-%d') = CURDATE())".
			" ) AND LENGTH(SUBSTRING_INDEX((lslog_price-ListPrice)*100*(-1)/lslog_price, '.',1)) <= 4 AND LM.MLSP_ID = '$MLSP_ID' ". // Listing Removed

			" ON DUPLICATE KEY UPDATE lslog_mls_num = VALUES(lslog_mls_num), lslog_price_per_sqft = VALUES(lslog_price_per_sqft)";

		# Show debug info
		if(DEBUG)
			$this->__debugMessage($sql);

		$db->query($sql);
	}
	#=========================================================================================================================
	#	Function Name	:   downloadMetaData
	#	Use				:	Download metadata for selected fields to use them with search form
	#-------------------------------------------------------------------------------------------------------------------------
	public function downloadMetaData($MLSP_ID)
	{
		global $db, $physical_path;

		// check for errors
		if (MLS_TRESTLE::obj()->Config['MLS_IS_API'] == 'Yes' && !empty(MLS_TRESTLE::obj()->Config['MLS_Client_ID']) && !empty(MLS_TRESTLE::obj()->Config['MLS_Client_Secret'])  && !empty(MLS_TRESTLE::obj()->Config['MLS_Browser_Token'])) {
			echo "  + Connected<br>\n";
		}
		else {
			echo "  + Not connected:<br>\n";
			echo " Missing Data";
			//print_r($rets->Error());
			exit;
		}

		//$Base_Url = MLS_BRIDGE::obj()->Config['MLS_Host']."/$metadata?";

		// API path
		$url = 'https://api-prod.corelogic.com/trestle/odata/$metadata';

		// Lets call API & get XML
		$result = Utility::readUrl($url, '', '', '', MLS_TRESTLE::obj()->Config['MLS_Browser_Token']);

		//MLS_BRIDGE::obj()->MLSP_ID
		// Save response to XML file
		$xmlFile = $physical_path['Cronjob'].'/'.$this->picPath['MLS_Pic_Folder'][MLS_TRESTLE::obj()->MLSP_ID].'/metadata.xml';

		file_put_contents($xmlFile, $result["Result"]);

		if(file_exists($xmlFile))
		{
			$xmlData = file_get_contents($xmlFile);

			$xmlData = $this->html_compress($xmlData);

			// We are getting all lookvalues in <EnumType></EnumType> tags, so find all those tags from xml file
			preg_match_all('#<EnumType[^>]*Name="([^"]*?)"[^>]*[^/]>(.*?)</EnumType>#is', $xmlData, $parsedData);

			Utility::pre($parsedData);
			$arrMeta = array();

			if(count($parsedData) > 0 && is_array($parsedData[1]) && is_array($parsedData[2]))
			{


				for($i=0; $i<count($parsedData[1]); $i++)
				{
					$arrMeta[$parsedData[1][$i]] = array();

					// Lets collect look values
					//preg_match_all('#<Member[^>]*Name="([^"]*?)"/>#is', $parsedData[2][$i], $parsedLookVals);
					preg_match_all('/<[\s]*Member[\s]*(?:name|property)="?' . '([^>"]*)"?[\s]*' . 'value="?([^>"]*)"?[\s]*[\/]?[\s]*>/si', $parsedData[2][$i], $parsedLookVals);

					if(count($parsedLookVals) > 0 && is_array($parsedLookVals[1]))
					{
						for($j=0; $j<count($parsedLookVals[1]); $j++)
						{
							array_push($arrMeta[$parsedData[1][$i]], $parsedLookVals[1][$j]);
						}
					}

				}
			}
			//Utility::pre($arrMeta);
			// Now we have array with fieldname & their lookup values
			if(count($arrMeta) > 0)
			{
				$Record = MLSConfig::obj()->getAllbyParam($this->MLSP_ID);

				foreach ($Record as $key => $recArr)
				{
					$arrLookup = explode(',',$recArr['LookupList']);
					$arrLookup = array_filter($arrLookup);
					$arrLookupField = explode(',',$recArr['LookupFieldList']);
					$arrLookupField = array_filter($arrLookupField);
					$arrFieldList = explode(',',$recArr['FieldList']);
					$arrFieldList = array_filter($arrFieldList);
					$arrSelectQuery = explode(',',$recArr['SelectQuery']);
					$arrSelectQuery = array_filter($arrSelectQuery);
					$arrFieldName = array();
					if ((count($arrSelectQuery)==count($arrFieldList)) && (count($arrSelectQuery) > 0 && count($arrFieldList) > 0))
						$arrFieldName = array_combine($arrSelectQuery,$arrFieldList);


					if (count($arrLookup)>0)
					{
						foreach ($arrLookup as $Lookupkey => $LookupVal)
						{

							if(array_key_exists($LookupVal, $arrMeta) !== false)
							{
								$arr_Data = $arrMeta[$LookupVal];

								if(count($arr_Data) > 0)
								{
									$ret = $this->InsertMetaData($this->MLSP_ID, $recArr['Resource'], $recArr['Class'], $LookupVal, $arrLookupField[$Lookupkey], $arrFieldName[$arrLookupField[$Lookupkey]], $arr_Data);
								}
							}
						}
					}
				}

				print "\n\nMetadata has been downloaded successfully\n\n";
			}
			else
			{
				print "\n\nDid not able to parse XML properly!\n\n";
			}
		}
	}
	#=========================================================================================================================
	#	Function Name	:   InsertMetaData
	#	Purpose			:	Insert New Meta & cleaup old ones
	#-------------------------------------------------------------------------------------------------------------------------
	public function InsertMetaData($mlsp_id, $Resource, $Class, $LookupVal, $LookupField, $Field_Name, $arrData)
	{
		global $db;

		$sql =	" DELETE FROM ". $this->Data['Metadata_Table'] .
			" WHERE MLSP_ID = '".$mlsp_id."' AND Resource = '".$Resource."' AND Lookup_Name = '".$LookupVal."' ";
		$db->query($sql);

		$sqlValues = array();

		foreach($arrData as $key => $val)
		{
			array_push($sqlValues, " ('".$mlsp_id."', ".
			                     " '".$Resource."', ".
			                     " '".$Class."', ".
			                     " '".$LookupVal."', ".
			                     " '".$LookupField."', ".
			                     " '".$Field_Name."', ".
			                     " '".addslashes($val)."', ".
			                     " '".addslashes($val)."', ".
			                     " '".addslashes($val)."')");

		}

		if(count($sqlValues) > 0)
		{
			$sql =	" INSERT INTO ". $this->Data['Metadata_Table'] .
				" (MLSP_ID, Resource, Class, Lookup_Name, Lookup_Field, Field_Name, LongValue, ShortValue, IDValue) ".
				" VALUES ".implode(",", $sqlValues);

			$db->query($sql);
		}

		return true;
	}
	#=========================================================================================================================
	#	Function Name	:   html_compress
	#	Use				:	Cleanup given html by removing extra spaces, lines, tabs etc...
	#-------------------------------------------------------------------------------------------------------------------------
	function html_compress($html)
	{
		//preg_match_all('!(<(?:code|pre).*>[^<]+</(?:code|pre)>)!',$html,$pre);#exclude pre or code tags

		//$html = preg_replace('!<(?:code|pre).*>[^<]+</(?:code|pre)>!', '#pre#', $html);#removing all pre or code tags

		$html = preg_replace('#<!�[^\[].+�>#', '', $html);#removing HTML comments

		$html = preg_replace('/[\r\n\t]+/', ' ', $html);#remove new lines, spaces, tabs

		$html = preg_replace('/>[\s]+</', '><', $html);#strip whitespaces after/before tags, except space

		$html = preg_replace('/[\s]+/', ' ', $html);#strip multiple whitespaces

		return $html;
	}
	#=========================================================================================================================

	#	Function Name	:   InsertPhotoData

	#	Purpose			:	data insert from temp table to photo table

	#-------------------------------------------------------------------------------------------------------------------------

	function InsertPhotoData($strListingIds='')

	{

		global $db;



		if($strListingIds != '')

		{

			$strListingIds = str_replace(",", "','", $strListingIds);



			// Delete Old entries from phoros table if any

			$sql =	" DELETE FROM ".$this->Data['MLS_Photo_Table'].

				" WHERE ListingKey IN('".$strListingIds."')";



			$db->query($sql);



			/*// Delete Old entries from virtual table if any

			$sql =	" DELETE FROM ".$this->Data['MLS_Virtual_Tour_Table'].

					" WHERE MLS_NUM IN('".$strListingIds."')";



			$db->query($sql);		*/



		}



		/*$sql =	" UPDATE ".$this->Data['MLS_Tmp_Photo_Data'].

			" SET Media_URL = REPLACE(Media_URL, 'http://', 'https://')";*/

		//" WHERE Media_Type = 'Photo'";



		//$db->query($sql);

		// Photo Data Transfer

		$sql =	" INSERT INTO ".$this->Data['MLS_Photo_Table'].

			" SELECT ListingKey, ".$this->MLSP_ID.", ListingKey, 'large', Media_Caption, Media_Description, Media_DisplayOrder, Media_URL, CURDATE()".

			" FROM ".$this->Data['MLS_Tmp_Photo_Data'];

		//" WHERE Media_Type = 'Photo'";



		$db->query($sql);

		$sql =	" UPDATE ".$this->Data['TableName']." M".
			" INNER JOIN ".$this->Data['MLS_Tmp_Photo_Data']." AS P ON M.ListingKey = P.ListingKey AND M.MLSP_ID = '".$this->MLSP_ID."'".
			" SET Pic_Download_Flag = 'Y', Pic_Updated_Date = NOW() ";

		$db->query($sql);

	}

    function InsertMainPhotoData($data)
    {
        global $db;
        $sql = " UPDATE ".$this->Data['TableName']." M".
            " SET Main_Photo_Url = '".$data['MediaURL']."' WHERE ListingKey = '".$data['ResourceRecordKey']. "' AND MLSP_ID = '".$this->MLSP_ID."'";
        $db->query($sql);
    }
	#=========================================================================================================================
	#	Function Name	:   downloadMetaData
	#	Use				:	Download metadata for selected fields to use them with search form
	#-------------------------------------------------------------------------------------------------------------------------
	public function GetFieldMetadata($MLSP_ID, $Resource = 'Property')
	{
		global $db, $physical_path;

		if(MLS_TRESTLE::obj()->Config['MLS_Token_Expire_Time'] == '' ||  MLS_TRESTLE::obj()->Config['MLS_Token_Expire_Time'] < date("Y-m-d H:i:s") || empty(MLS_TRESTLE::obj()->Config['MLS_Browser_Token']))
		{
			$rets_login_url = MLS_TRESTLE::obj()->Config['MLS_Token_URL'];
			$client_id = MLS_TRESTLE::obj()->Config['MLS_Client_ID'];
			$secret = MLS_TRESTLE::obj()->Config['MLS_Client_Secret'];

			$param = "scope=api&client_secret={$secret}&grant_type=client_credentials&client_id={$client_id}";

			$res = Utility::readUrl($rets_login_url, $param, '', '', '');
		//echo "<pre>";print_r($res);die;
			$res = json_decode($res['Result'], true);

			MLSMaster::obj()->UpdateJobInfo(MLS_TRESTLE::obj()->MLSP_ID, 'mls_browser_token', $res['access_token']);
			$time = date("Y-m-d H:i:s", strtotime("+".$res['expires_in']." seconds"));
			MLSMaster::obj()->UpdateJobInfo(MLS_TRESTLE::obj()->MLSP_ID, 'mls_token_expire_time', $time);
		}
		
		MLS_TRESTLE::obj(true);
		// check for errors
		/*if (MLS_TRESTLE::obj()->Config['MLS_IS_API'] == 'Yes' && !empty(MLS_TRESTLE::obj()->Config['MLS_Client_ID']) && !empty(MLS_TRESTLE::obj()->Config['MLS_Client_Secret'])  && !empty(MLS_TRESTLE::obj()->Config['MLS_Browser_Token'])) {
			echo "  + Connected<br>\n";
		}
		else {
			echo "  + Not connected:<br>\n";
			echo " Missing Data";
			//print_r($rets->Error());
			exit;
		}*/

		//$Base_Url = MLS_BRIDGE::obj()->Config['MLS_Host']."/$metadata?";

		// API path
		$url = 'https://api-prod.corelogic.com/trestle/odata/$metadata';

		// Lets call API & get XML
		$result = Utility::readUrl($url, '', '', '', MLS_TRESTLE::obj()->Config['MLS_Browser_Token']);

		// Save response to XML file
		$xmlFile = $physical_path['Cronjob'].'/'.$this->picPath['MLS_Pic_Folder'][MLS_TRESTLE::obj()->MLSP_ID].'/metadata.xml';

		file_put_contents($xmlFile, $result["Result"]);

		if(file_exists($xmlFile))
		{
			$xmlData = file_get_contents($xmlFile);

			$xmlData = $this->html_compress($xmlData);

			// We are getting all lookvalues in <EntityType></EntityType> tags, so find all those tags from xml file
			preg_match_all('#<EntityType Name="'.$Resource.'">(.*?)</EntityType>#is', $xmlData, $parsedData);

			preg_match_all('#<Property Name="(.*?)"(.*?)/>#is', $parsedData[1][0], $parsedLookVals);
			
			return $parsedLookVals[1];
			
		}
	}

}

?>