<?php

class MLS_Trestle_Acris extends MLSProvider
{
    public $MLSP_ID = 1;
    public $Config = array();
    public $mlsRecord = array();
    public $Data;

    public static $Instance;

    public static function obj()
    {
        if(!is_object(self::$Instance))
            self::$Instance = new self();

        return self::$Instance;
    }

    public function __construct($isPopulateSchema=false)
    {
        global $config;

        # Make call to parent constructor
        parent::__construct();
    }

    #=========================================================================================================================
    #	Function Name	:   get_Pending_Document_Download_Sold_Listing
    #-------------------------------------------------------------------------------------------------------------------------
    public function get_Pending_Document_Download_Sold_Listing($MLSP_ID, $limit='', $status='', $propertyType='')
    {

        global $db;
        $addParams = '';

        if($status != '')
            $addParams .= " AND listing_status IN ('".str_replace(',', "','", $status)."')";

        if($propertyType != '')
            $addParams .= " AND property_type IN ('".str_replace(',', "','", $propertyType)."')";

        $sql	= " SELECT te_mlsp_id, sale_trans_id, county, street_name, street_number, street_suffix, unit_no, street_dir_suffix, address, tax_lot, tax_block"
            . " FROM ". $this->Data['Sales_Table']
            . " WHERE te_is_mark_for_deletion = 'N' AND te_mlsp_id = ". $MLSP_ID
            . " AND (te_doc_process_flag  = 'N' AND te_doc_process_date IS NULL)"
            . $addParams
            . " ORDER BY te_doc_process_date";

        if ($limit!='')
            $sql .= " LIMIT 0 , ".$limit;

        $rs = $db->query($sql);


        if($rs->TotalRow == 0){
            $sql	= " SELECT te_mlsp_id, sale_trans_id, county, street_name, street_number, street_suffix, unit_no, street_dir_suffix, address, tax_lot, tax_block"
                . " FROM ". $this->Data['Sales_Table']
                . " WHERE te_is_mark_for_deletion = 'N' AND te_mlsp_id = ". $MLSP_ID
                . " AND (te_doc_process_flag  In ('U', 'A', 'M') AND (te_doc_process_date <= NOW() OR te_doc_process_date IS NULL))"
                . $addParams
                . " ORDER BY te_doc_process_date";

            if ($limit!='')
                $sql .= " LIMIT 0 , ".$limit;

            $rs = $db->query($sql);
        }

        return ($rs->fetch_array());
    }

    #=========================================================================================================================
    #	Function Name	:   SetSoldListingDocumentDownloadFlag
    #-------------------------------------------------------------------------------------------------------------------------
    public function SetSoldListingDocumentDownloadFlag($Process_Flag='N', $MLS_NUM, $MLSP_ID)
    {
        global $db;

        # Define query
        $sql =	" UPDATE ". $this->Data['Sales_Table'].
            " SET te_doc_process_flag = '".$Process_Flag."', te_doc_process_date = NOW()".
            " WHERE sale_trans_id = '".$MLS_NUM."' And te_mlsp_id = ".$MLSP_ID;

        $db->query($sql);

        return true;
    }
    
     #=========================================================================================================================
    #	Function Name	:   getSalesandRentalListings
    #-------------------------------------------------------------------------------------------------------------------------
    public function getSalesandRentalListings($type, $limit = '')
    {
        global $db;
        $tbl = '';
        $fields = '';

        if ($type == 'sales' || $type == 'rentals') {
            $tbl = $type == 'sales' ? $this->Data['Sales_Table'] : $this->Data['Rentals_Table'];
            $idField = $type == 'sales' ? 'sale_trans_id' : 'rental_trans_id';

            $fields = $idField . " as id, address, address2, CONCAT_WS(' ', street_number, street_name, street_suffix) as addr, 
                CONCAT_WS(' ', street_number, street_name) as buildingname,
                building_name, property_type, subtype, total_units, stories, cross_street, elevators_total, 
                maximum_financing_percent, year_built, garage, county, unit_no as unit_number, common_interest, common_charges, 
                maintenance, tax_block, tax_lot, exterior_features, laundry_features, building_features, flip_tax, flip_tax_type,
                tax_abatement_yn, renting_allowed_yn, pets_allowed, certificate_of_occupancy_yn, attendance_type, 
                beds, baths, bathfull, bathhalf, sqft, year_built, garage, current_price, original_list_price as list_price, occupant_type, 
                view, patio_and_porch_features, kitchen_condition, exposures, bathroom_condition, tax_monthly_amount, unit_line, sponsor_unit_yn,
                closets_total, heating, cooling, street_number, street_name, street_suffix, zipcode";

            if ($type == 'rentals') {
                $fields .= ", rental_price";  
            }
        } else {
            return null;
        }

        $sql = "SELECT " . $fields
            . " FROM " . $tbl
            . " WHERE (building_id IS NULL OR unit_id IS NULL) ORDER BY building_name, street_number, street_name, street_suffix";  
        if ($limit != '') {
            $sql .= " LIMIT 0 , " . $limit;
        }

        $rs = $db->query($sql);

        return $rs->fetch_array();
    }

    public function setBuildingUnitId($id, $building_id, $unit_id, $type)
    {
        global $db;
        $tbl ="";

        if ($type == 'sales') {
            $tbl = $this->Data['Sales_Table'];
            $idFld = "sale_trans_id";
        }
        else if($type == 'rentals') {
            $tbl = $this->Data['Rentals_Table'];
            $idFld = "rental_trans_id";
        }

        $sql =	" UPDATE ". $tbl.
            " SET building_id = ".$building_id.", unit_id = ".$unit_id.
            " WHERE ".$idFld." = '".$id."'";

        $db->query($sql);

        return true;
    }

}

?>