<?php
#=============================================================================================================================
#	File Name		:	MLSMaster.php
#=============================================================================================================================
# Include data
//require_once(dirname(__FILE__) . '/MLSMasterData.php');

class NonMLSListingMaster extends CustomClass
{
    public static $Instance;

	public static function obj()
	{
		if(!is_object(self::$Instance))
			self::$Instance = new self();

		return self::$Instance;
	}
    #=========================================================================================================================
	#	Function Name	:   NonMLSListingMasterData
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
    public function __construct()
    {
		global $physical_path, $virtual_path, $asset, $config;

		# Initialize all default data

		# Table name
		$this->Data['TableName']			=	$config['Table_Prefix']. 'acris_property_master';

		# Module title
		$this->Data['L_Module']				=	'ACRIS Property Master';

		# Primary field info
		$this->Data['F_PrimaryKey']			=	'id';


		# Intialize parent class
		parent::__construct();
	}
    #=========================================================================================================================
    #	Function Name	:   Insert
    #	Purpose			:	Insert new information
    #	Return			:	Return insert status
    #-------------------------------------------------------------------------------------------------------------------------
    public function InsertNonMLSListings($arrdata, $document_id, $RPLResult)
    {
        $ret_array = array();
        /* get mls number from TRESTLE data if exist */
        $arrMls = DocumentMaster::obj()->getDocumentInfoByParam($document_id, DATA_RESOURCE_TRESTLE);

        if ($arrMls != null && count($arrMls) > 0){
            if(count($arrMls) == 1)
                $mls_num= $arrMls['te_mls_num'];
            else{
                $arrmlsdata = [];
                foreach ($arrMls as $k=>$v){
                    $arrmlsdata[] = $v['te_mls_num'];
                }
                $mls_num = implode(",", $arrmlsdata);
            }
        }
        else{
            $mls_num= "";
        }
        global $db;
        $POST = [];

        $POST['record_type']            = $RPLResult-> record_type;
        $POST['borough']                = $RPLResult-> borough;
        $POST['block']                  = $RPLResult-> block;
        $POST['lot']                    = $RPLResult-> lot;
        $POST['easement']               = $RPLResult-> easement;
        $POST['partial_lot']            = $RPLResult-> partial_lot;
        $POST['air_rights']             = $RPLResult-> air_rights;
        $POST['subterranean_rights']    = $RPLResult-> subterranean_rights;
        $POST['property_type']          = $RPLResult->property_type;
        $POST['street_number']          = $RPLResult-> street_number;
        $POST['street_name']            = $arrdata-> street_name;
        $POST['unit']                   = isset($RPLResult-> unit)?$RPLResult-> unit:"";
        $POST['good_through_date']      = $RPLResult-> good_through_date;
        $POST['zip_code']               = $arrdata-> zip_code;
        $POST['parid']                  = $arrdata-> parid;
        //$mls
        $POST['housenum_lo']            = $arrdata-> housenum_lo;
        $POST['housenum_hi']            = $arrdata-> housenum_hi;
        $POST['bld_story']              = $arrdata-> bld_story;
        $POST['yrbuilt']                = $arrdata-> yrbuilt;
        $POST['yralt1']                 = $arrdata-> yralt1;
        $POST['aptno']                  = $arrdata-> aptno;
        $POST['appt_boro']              = $arrdata-> appt_boro;
        $POST['appt_block']             = $arrdata-> appt_block;
        $POST['appt_lot']               = $arrdata-> appt_lot;
        $POST['condo_number']           = $arrdata-> condo_number;
        $POST['residential_area_gross'] = $arrdata-> residential_area_gross;


        $sql =	" INSERT INTO ".$this->Data['TableName'].
            " (document_id, record_type, borough, block, lot, easement, partial_lot, air_rights, subterranean_rights, property_type, street_number, street_name, unit, good_through_date, 
            zip_code, parid, mls_num, housenum_lo, housenum_hi, bld_story, yrbuilt, yralt1, aptno, appt_boro, appt_block, appt_lot, condo_number, residential_area_gross)".
            " VALUES ( '".$document_id."',
            '".$POST['record_type']."',
            '".$POST['borough']."',
            '".$POST['block']."', 
            '".$POST['lot']."', 
            '".$POST['easement']."', 
            '".$POST['partial_lot']."',
            '".$POST['air_rights']."',
            '".$POST['subterranean_rights']."',
            '".$POST['property_type']."', 
            '".$POST['street_number']."', 
            '".$POST['street_name']."', 
            '".$POST['unit']."', 
            '".$POST['good_through_date']."',
            '".$POST['zip_code']."', 
            '".$POST['parid']."', 
            '".$mls_num."', 
            '".$POST['housenum_lo']."', 
            '".$POST['housenum_hi']."', 
            '".$POST['bld_story']."', 
            '".$POST['yrbuilt']."', 
            '".$POST['yralt1']."', 
            '".$POST['aptno']."', 
            '".$POST['appt_boro']."', 
            '".$POST['appt_block']."', 
            '".$POST['appt_lot']."', 
            '".$POST['condo_number']."', 
            '".$POST['residential_area_gross']."'
                      )".
           " ON DUPLICATE KEY UPDATE 
            document_id = VALUES(document_id), record_type = VALUES(record_type), borough = VALUES(borough), block = VALUES(block), lot = VALUES(lot), easement = VALUES(easement), partial_lot = VALUES(partial_lot), air_rights = VALUES(air_rights), subterranean_rights = VALUES(subterranean_rights), property_type = VALUES(property_type), street_number = VALUES(street_number), street_name = VALUES(street_name), unit = VALUES(unit), good_through_date = VALUES(good_through_date), 
            zip_code = VALUES(zip_code), parid = VALUES(parid), mls_num = VALUES(mls_num), housenum_lo = VALUES(housenum_lo), housenum_hi = VALUES(housenum_hi), bld_story = VALUES(bld_story), yrbuilt = VALUES(yrbuilt), yralt1 = VALUES(yralt1), aptno = VALUES(aptno), appt_boro = VALUES(appt_boro), appt_block = VALUES(appt_block), appt_lot = VALUES(appt_lot), condo_number = VALUES(condo_number), residential_area_gross = VALUES(residential_area_gross) ";

            //echo $sql;die;
        $val = $db->query($sql);
        $last_id = $db->Link_ID->insert_id;
        
        if($last_id == 0){
            $sql=" SELECT id FROM ".$this->Data['TableName']." WHERE parid=".$POST['parid'];
            if($POST['unit'] != ''){
                $sql.=" AND unit = '".$POST['unit']."'";
            }
            $sql.=" AND block = ".$POST['block'];
            $sql.=" AND lot = ".$POST['lot'];
            $sql.=" AND document_id = ".$document_id;
            if($mls_num != ''){
                $sql.=" AND mls_num IN ('".str_replace(",", "','", $mls_num)."')";
            }
            
            //file_put_contents('query2.txt', print_r($sql,true), FILE_APPEND);

            $query = $db->query($sql);
            $result = $query->fetch_array();
            
            if(isset($result[0])){
                $last_id = $result[0]['id'];
            }
            else{
                $last_id = 0;
            }
        }
        $ret_array['success']= $val;
        $ret_array['last_id']= $last_id;
        $ret_array['mls_num']= $mls_num;
        
        return $ret_array;
    }
    
    public function getAcrisListings($limit='')
    {
        global $db;
        
        $sql = " SELECT id,  CONCAT_WS(' ', street_number, street_name) as addr, property_type, bld_story as stories, yrbuilt as year_built, 
                yralt1 as year_altered, borough, unit as unit_number, block as tax_block, lot as tax_lot, condo_number, street_number, street_name, condo_number,
                easement, partial_lot, air_rights, subterranean_rights, property_type, zip_code, housenum_lo, housenum_hi, 	aptno, appt_block, appt_lot,
                residential_area_gross" 
            . " FROM ". $this->Data['TableName']
            . " WHERE (building_id IS NULL OR unit_id IS NULL) AND Property_type not in ( 'SC', 'MC', 'MP', 'SM', 'BS', 'CA', 'CC', 'CK', 'CP','SP')"
            . " ORDER BY street_number, street_name"; 

        if ($limit!='')
            $sql .= " LIMIT 0 , ".$limit;          

        $rs = $db->query($sql);

        return $rs->fetch_array();
    }

    public function setBuildingUnitId($id, $building_id, $unit_id)
    {
        global $db;

        $sql =	" UPDATE ". $this->Data['TableName'].
            " SET building_id = ".$building_id.", unit_id = ".$unit_id.
            " WHERE id = ".$id;

        $db->query($sql);

        return true;
    }

}
?>