<?php
#=============================================================================================================================
#	File Name		:	UnitsMaster.php
#=============================================================================================================================
# 

class UnitsMaster extends CustomClass
{
    public static $Instance;

	public static function obj()
	{
		if(!is_object(self::$Instance))
			self::$Instance = new self();

		return self::$Instance;
	}
    #=========================================================================================================================
	#	Function Name	:   UnitsMasterData
	#	Purpose			:	Simple constructor
	#	Return			:	None
	#-------------------------------------------------------------------------------------------------------------------------
    public function __construct()
    {
		global $config;

		# Initialize all default data

		# Table name
		$this->Data['TableName']			=	$config['Table_Prefix']. 'units';

		# Module title
		$this->Data['L_Module']				=	'Units Master';

		$this->Data['F_PrimaryKey']			=	'unit_id';

		# Intialize parent class
		parent::__construct();
	}
    #=========================================================================================================================
    #	Function Name	:   Insert
    #	Purpose			:	Insert new information
    #	Return			:	Return insert status
    #-------------------------------------------------------------------------------------------------------------------------
    public function InsertUnits($Record, $source, $building_id)
    {
        global $db, $asset;
		$arrdata = [];

        $arrdata['te_mls_num'] = $Record['id'];      
        $arrdata['building_id'] = $building_id;
        $arrdata['unit_number'] = isset($Record['unit_number']) && !empty($Record['unit_number']) ?$Record['unit_number']:1;
        $arrdata['common_interest'] = $Record['common_interest'] ?? "";
        $arrdata['common_charges'] = $Record['common_charges'] ?? 0;
        $arrdata['maintenance'] = $Record['maintenance'] ?? 0;
        $arrdata['tax_block'] = $Record['tax_block'] ?? '';
        $arrdata['tax_lot'] = $Record['tax_lot'] ?? '';
        $arrdata['exterior_features'] = trim($Record['exterior_features']) ?? '';
        $arrdata['laundry_features'] = trim($Record['laundry_features']) ?? '';
        $arrdata['building_features'] = trim($Record['building_features']) ?? '';
        $arrdata['flip_tax'] = trim($Record['flip_tax']) ?? '';
        $arrdata['flip_tax_type'] = trim($Record['flip_tax_type']) ?? '';
        $arrdata['tax_abatement_yn'] = $Record['tax_abatement_yn'] ?? 0;
        $arrdata['renting_allowed_yn'] = $Record['renting_allowed_yn'] ?? 0;
        $arrdata['pets_allowed'] = $Record['pets_allowed'] ?? 0;
        $arrdata['certificate_of_occupancy_yn'] = $Record['certificate_of_occupancy_yn'] ?? 0;
        $arrdata['attendance_type'] = trim($Record['attendance_type']) ?? '';
        $arrdata['maximum_financing_percent'] = isset($Record['maximum_financing_percent']) && !empty(trim($Record['maximum_financing_percent']))? $Record['maximum_financing_percent'] : 0;
        $arrdata['beds'] = $Record['beds'] ?? 0;
        $arrdata['baths'] = $Record['baths'] ?? 0;
        $arrdata['baths_full'] = $Record['bathfull'] ?? 0;
        $arrdata['baths_half'] = $Record['bathhalf'] ?? 0;
        $arrdata['sqft'] = $Record['sqft'] ?? 0;
        $arrdata['year_built'] = $Record['year_built'] ?? 0;
        $arrdata['garage'] = $Record['garage'] ?? '';
        $arrdata['current_price'] = $Record['current_price'] ?? 0;
        $arrdata['list_price'] = $Record['list_price'] ?? 0;
        $arrdata['rental_price'] = $Record['rental_price'] ?? 0;
        $arrdata['occupant_type'] = trim($Record['occupant_type']) ?? '';
        $arrdata['view'] = trim($Record['view']) ?? '';
        $arrdata['patio_and_porch_features'] = trim($Record['patio_and_porch_features']) ?? '';
        $arrdata['kitchen_condition'] = trim($Record['kitchen_condition']) ?? '';
        $arrdata['exposures'] = trim($Record['exposures']) ?? '';
        $arrdata['bathroom_condition'] = trim($Record['bathroom_condition']) ?? '';
        $arrdata['tax_monthly_amount'] = $Record['tax_monthly_amount'] ?? 0;
        $arrdata['unit_line'] = trim($Record['unit_line']) ?? '';
        $arrdata['sponsor_unit_yn'] = $Record['sponsor_unit_yn'] ?? 0;
        $arrdata['closets_total'] = isset($Record['closets_total']) && !empty(trim($Record['closets_total']))? $Record['closets_total'] : 0;
        $arrdata['heating'] = trim($Record['heating']) ?? '';
        $arrdata['cooling'] = trim($Record['cooling']) ?? '';
        $arrdata['te_mls_source'] = $source;  
        $arrdata['stories'] = $Record['stories'];

        $arrdata['building_type'] = trim($Record['common_interest']);
		$arrdata['elevators_total'] = isset($Record['elevators_total']) && !empty(trim($Record['elevators_total'])) ?$Record['elevators_total']:0;
        $arrdata['cross_street'] = isset($Record['cross_street']) && !empty(trim($Record['cross_street'])) ? trim($Record['cross_street']) : '';

        $arrdata['property_type'] = $Record['property_type'];
        $arrdata['zip_code'] = $Record['zipcode'];
        //$arrdata['te_building_name'] = isset($Record['building_name']) && !empty($Record['building_name']) && $Record['building_name'] != null && $Record['building_name'] != 'null'? $Record['building_name'] :$Record['buildingname'];  
	
		$sql =	" INSERT INTO ".$this->Data['TableName'].
		"(building_id, unit_number, common_interest, common_charges, maintenance, tax_block, tax_lot, exterior_features, building_type,
        laundry_features, building_features, flip_tax, flip_tax_type, tax_abatement_yn, renting_allowed_yn, pets_allowed, certificate_of_occupancy_yn, 
        attendance_type, maximum_financing_percent, beds, baths, baths_full, baths_half, sqft, year_built, garage, current_price, 
        list_price, rental_price, occupant_type, view, patio_and_porch_features, kitchen_condition, exposures, bathroom_condition, tax_monthly_amount, 
        unit_line, sponsor_unit_yn, closets_total, heating, cooling, te_mls_num, te_mls_source, elevators_total, cross_street, stories, property_type, zip_code)".
		" VALUES (
        ".$arrdata['building_id'].", 
        '".$arrdata['unit_number']."', 
        '".$arrdata['common_interest']."', 
        ".$arrdata['common_charges'].", 
        ".$arrdata['maintenance'].", 
        '".$arrdata['tax_block']."', 
        '".$arrdata['tax_lot']."', 
        '".$arrdata['exterior_features']."', 
        '".$arrdata['building_type']."', 
        '".$arrdata['laundry_features']."', 
        '".$arrdata['building_features']."', 
        '".$arrdata['flip_tax']."', 
        '".$arrdata['flip_tax_type']."', 
        ".$arrdata['tax_abatement_yn'].", 
        ".$arrdata['renting_allowed_yn'].", 
        '".$arrdata['pets_allowed']."', 
        ".$arrdata['certificate_of_occupancy_yn'].", 
        '".$arrdata['attendance_type']."', 
        ".$arrdata['maximum_financing_percent'].", 
        ".$arrdata['beds'].", 
        ".$arrdata['baths'].", 
        ".$arrdata['baths_full'].", 
        ".$arrdata['baths_half'].", 
        ".$arrdata['sqft'].", 
        ".$arrdata['year_built'].", 
        '".$arrdata['garage']."', 
        ".$arrdata['current_price'].", 
        ".$arrdata['list_price'].", 
        ".$arrdata['rental_price'].", 
        '".$arrdata['occupant_type']."', 
        '".$arrdata['view']."', 
        '".$arrdata['patio_and_porch_features']."', 
        '".$arrdata['kitchen_condition']."', 
        '".$arrdata['exposures']."', 
        '".$arrdata['bathroom_condition']."', 
        ".$arrdata['tax_monthly_amount'].", 
        '".$arrdata['unit_line']."', 
        ".$arrdata['sponsor_unit_yn'].", 
        ".$arrdata['closets_total'].", 
        '".$arrdata['heating']."', 
        '".$arrdata['cooling']."', 
        '".$arrdata['te_mls_num']."',
        '".$arrdata['te_mls_source']."',
        ".$arrdata['elevators_total'].",
        '".$arrdata['cross_street']."',
        ".$arrdata['stories'].",
        '".$arrdata['property_type']."',
        '".$arrdata['zip_code']."'
        )";
			
        $data = $db->query($sql);

		$lastId = $db->Link_ID->insert_id;
        return $lastId;
    }

    public function InsertAcrisUnits($Record, $source, $building_id)
    {
        global $db, $asset;
		$arrdata = [];

        $arrdata['te_non_mls_id'] = $Record['id'];       
        $arrdata['building_id'] = $building_id;
        //$arrdata['unit_number'] = $Record['unit_number'];
        $arrdata['unit_number'] = isset($Record['unit_number']) && !empty($Record['unit_number']) ?$Record['unit_number']:1;
        $arrdata['tax_block'] = trim($Record['tax_block']) ?? '';
        $arrdata['tax_lot'] = trim($Record['tax_lot']) ?? '';
        $arrdata['year_built'] = $Record['year_built'] ?? 0;
        $arrdata['year_altered'] = $Record['year_altered'] ?? 0;
        $arrdata['te_mls_source'] = $source;  
        $arrdata['te_building_name'] = isset($Record['building_name']) && !empty($Record['building_name']) && $Record['building_name'] != null && $Record['building_name'] != 'null'? $Record['building_name'] :$Record['buildingname'];  
        $arrdata['property_type'] = $Record['property_type'];
        $arrdata['easement'] = $Record['easement'];
        $arrdata['partial_lot'] = $Record['partial_lot'];
        $arrdata['air_rights'] = $Record['air_rights'];
        $arrdata['subterranean_rights'] = $Record['subterranean_rights'];
        $arrdata['zip_code'] = $Record['zip_code'];
        $arrdata['housenum_lo'] = $Record['housenum_lo'];
        $arrdata['housenum_hi'] = $Record['housenum_hi'];
        $arrdata['aptno'] = $Record['aptno'];
        $arrdata['appt_block'] = $Record['appt_block'];
        $arrdata['appt_lot'] = $Record['appt_lot'];
        $arrdata['residential_area_gross'] = $Record['residential_area_gross'];
        $arrdata['stories'] = $Record['stories'];
	
		$sql =	" INSERT INTO ".$this->Data['TableName'].
		"(building_id, unit_number, tax_block, tax_lot, year_built, year_altered, easement, partial_lot, air_rights, subterranean_rights, 
        property_type, zip_code, housenum_lo, housenum_hi, aptno, appt_block, appt_lot, residential_area_gross, te_non_mls_id, te_mls_source, stories)".
		" VALUES (
        ".$arrdata['building_id'].", 
        '".$arrdata['unit_number']."', 
        '".$arrdata['tax_block']."', 
        '".$arrdata['tax_lot']."',         
        ".$arrdata['year_built'].", 
        ".$arrdata['year_altered'].", 
        '".$arrdata['easement']."',
        '".$arrdata['partial_lot']."',
        '".$arrdata['air_rights']."',
        '".$arrdata['subterranean_rights']."',
        '".$arrdata['property_type']."',
        '".$arrdata['zip_code']."',
        '".$arrdata['housenum_lo']."',
        '".$arrdata['housenum_hi']."',
        '".$arrdata['aptno']."',
        '".$arrdata['appt_block']."',
        '".$arrdata['appt_lot']."',
        '".$arrdata['residential_area_gross']."',
        ".$arrdata['te_non_mls_id'].", 
        '".$arrdata['te_mls_source']."',
        ".$arrdata['stories']."
        )";
			
        $data = $db->query($sql);
		$lastId = $db->Link_ID->insert_id;
        return $lastId;
    }
}
?>